
;CodeVisionAVR C Compiler V2.04.8a Standard
;(C) Copyright 1998-2010 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type                : ATmega32
;Program type             : Application
;Clock frequency          : 8,000000 MHz
;Memory model             : Small
;Optimize for             : Speed
;(s)printf features       : int, width
;(s)scanf features        : int, width
;External RAM size        : 0
;Data Stack size          : 512 byte(s)
;Heap size                : 0 byte(s)
;Promote 'char' to 'int'  : Yes
;'char' is unsigned       : Yes
;8 bit enums              : Yes
;global 'const' stored in FLASH: Yes
;Enhanced core instructions    : On
;Smart register allocation     : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega32
	#pragma AVRPART MEMORY PROG_FLASH 32768
	#pragma AVRPART MEMORY EEPROM 1024
	#pragma AVRPART MEMORY INT_SRAM SIZE 2048
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	#define CALL_SUPPORTED 1

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __SRAM_START=0x0060
	.EQU __SRAM_END=0x085F
	.EQU __DSTACK_SIZE=0x0200
	.EQU __HEAP_SIZE=0x0000
	.EQU __CLEAR_SRAM_SIZE=__SRAM_END-__SRAM_START+1

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM

	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM

	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+(@1)
	ANDI R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ANDI R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ANDD2N
	ANDI R26,LOW(@0)
	ANDI R27,HIGH(@0)
	ANDI R24,BYTE3(@0)
	ANDI R25,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+(@1)
	ORI  R30,LOW(@2)
	STS  @0+(@1),R30
	LDS  R30,@0+(@1)+1
	ORI  R30,HIGH(@2)
	STS  @0+(@1)+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD2N
	ORI  R26,LOW(@0)
	ORI  R27,HIGH(@0)
	ORI  R24,BYTE3(@0)
	ORI  R25,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __CLRD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+(@1))
	LDI  R31,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	LDI  R22,BYTE3(2*@0+(@1))
	LDI  R23,BYTE4(2*@0+(@1))
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+(@1))
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+(@2))
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+(@3))
	LDI  R@1,HIGH(@2+(@3))
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+(@3))
	LDI  R@1,HIGH(@2*2+(@3))
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+(@1)
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+(@1)
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	LDS  R22,@0+(@1)+2
	LDS  R23,@0+(@1)+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+(@2)
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+(@3)
	LDS  R@1,@2+(@3)+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+(@1)
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+(@1)
	LDS  R27,@0+(@1)+1
	LDS  R24,@0+(@1)+2
	LDS  R25,@0+(@1)+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+(@1),R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+(@1),R30
	STS  @0+(@1)+1,R31
	STS  @0+(@1)+2,R22
	STS  @0+(@1)+3,R23
	.ENDM

	.MACRO __PUTB1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRB
	.ENDM

	.MACRO __PUTW1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRW
	.ENDM

	.MACRO __PUTD1EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMWRD
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+(@1),R0
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+(@1),R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+(@1),R@2
	STS  @0+(@1)+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTBSR
	STD  Y+@1,R@0
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+(@1)
	LDS  R31,@0+(@1)+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+(@1))
	LDI  R31,HIGH(2*@0+(@1))
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+(@1))
	LDI  R27,HIGH(@0+(@1))
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __GETD1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X+
	LD   R22,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __GETBRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	LD   R@0,X
	.ENDM

	.MACRO __GETWRSX2
	MOVW R26,R28
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	LD   R@0,X+
	LD   R@1,X
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __CLRD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R30
	ST   X+,R30
	ST   X,R30
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	ST   Z,R@0
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

;NAME DEFINITIONS FOR GLOBAL VARIABLES ALLOCATED TO REGISTERS
	.DEF __lcd_x=R5
	.DEF __lcd_y=R4
	.DEF __lcd_maxx=R7

	.CSEG
	.ORG 0x00

;START OF CODE MARKER
__START_OF_CODE:

;INTERRUPT VECTORS
	JMP  __RESET
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00
	JMP  0x00

_TexteMenuAcquiter:
	.DB  0x20,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x20,0x5B,0x45,0x4E,0x54,0x52,0x5D,0x20
	.DB  0x0
_TexteMenuAcquitQuitter:
	.DB  0x20,0x5B,0x45,0x4E,0x54,0x52,0x5D,0x20
	.DB  0x5B,0x45,0x43,0x48,0x41,0x50,0x5D,0x20
	.DB  0x0
_TexteMenuReglerHTR:
	.DB  0x5B,0x31,0x5D,0x20,0x52,0x65,0x67,0x6C
	.DB  0x61,0x67,0x65,0x20,0x48,0x54,0x52,0x20
	.DB  0x0
_TexteMenusAfficher:
	.DB  0x5B,0x32,0x5D,0x20,0x41,0x66,0x66,0x69
	.DB  0x63,0x68,0x61,0x67,0x65,0x73,0x20,0x20
	.DB  0x0
_TexteMenusTester:
	.DB  0x5B,0x33,0x5D,0x20,0x54,0x65,0x73,0x74
	.DB  0x73,0x20,0x20,0x20,0x20,0x20,0x20,0x20
	.DB  0x0
_TexteMenuRegulerTOR:
	.DB  0x5B,0x34,0x5D,0x20,0x52,0x65,0x67,0x75
	.DB  0x6C,0x2E,0x20,0x54,0x4F,0x52,0x20,0x20
	.DB  0x0
_TexteMenuHeureOuDate:
	.DB  0x20,0x53,0x45,0x54,0x3E,0x48,0x20,0x45
	.DB  0x54,0x52,0x3E,0x44,0x61,0x74,0x65,0x20
	.DB  0x0
_TexteMenuPlusMoinsEsc:
	.DB  0x5B,0x2B,0x5D,0x20,0x5B,0x2D,0x5D,0x20
	.DB  0x5B,0x45,0x43,0x48,0x41,0x50,0x5D,0x20
	.DB  0x0
_TexteSousMenuChauffage:
	.DB  0x5B,0x33,0x31,0x5D,0x20,0x54,0x65,0x73
	.DB  0x74,0x20,0x43,0x68,0x61,0x75,0x66,0x20
	.DB  0x0
_TexteSousMenuVentilation:
	.DB  0x5B,0x33,0x32,0x5D,0x20,0x54,0x65,0x73
	.DB  0x74,0x20,0x56,0x65,0x6E,0x74,0x2E,0x20
	.DB  0x0
_TexteSousMenuTrappes:
	.DB  0x5B,0x33,0x33,0x5D,0x20,0x54,0x65,0x73
	.DB  0x74,0x20,0x54,0x72,0x61,0x70,0x2E,0x20
	.DB  0x0
_IconeFlecheHaut:
	.DB  0x4,0xE,0x15,0x4,0x4,0x4,0x4,0x0
_IconeFlecheBas:
	.DB  0x4,0x4,0x4,0x4,0x15,0xE,0x4,0x0
_IconeJour:
	.DB  0x4,0xA,0x11,0x4,0x11,0xA,0x4,0x0
_IconeNuit:
	.DB  0x0,0x6,0x7,0x7,0x7,0x6,0x0,0x0
_tbl10_G100:
	.DB  0x10,0x27,0xE8,0x3,0x64,0x0,0xA,0x0
	.DB  0x1,0x0
_tbl16_G100:
	.DB  0x0,0x10,0x0,0x1,0x10,0x0,0x1,0x0

;REGISTER BIT VARIABLES INITIALIZATION
__REG_BIT_VARS:
	.DW  0x000C

_0x6:
	.DB  0x0,0x0,0x1,0x0,0x0,0x0,0x1,0x0
	.DB  0x0,0x64,0x0,0xCC,0x0,0x30,0x1,0x98
	.DB  0x1,0xFC,0x1,0x64,0x2,0xC8,0x2,0x30
	.DB  0x3,0x94,0x3,0xFF,0x3,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x30,0x30,0x30,0x0,0x30,0x30,0x2E
	.DB  0x30,0x0,0x30,0x30,0x2E,0x30,0x0,0x30
	.DB  0x30,0x2E,0x30,0x0,0x4A,0x6F,0x75,0x72
	.DB  0x0,0x30,0x30,0x2E,0x30,0x0,0x1,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0xB4,0x41,0x0,0x0,0xAC
	.DB  0x41,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x5,0x0,0x0,0x0,0x0,0x0,0x0,0x0
	.DB  0x0
_0x0:
	.DB  0x20,0x50,0x50,0x45,0x20,0x53,0x45,0x52
	.DB  0x52,0x45,0x20,0x53,0x49,0x53,0x49,0x20
	.DB  0x0,0x20,0x4D,0x61,0x6A,0x3A,0x30,0x31
	.DB  0x2F,0x31,0x32,0x2F,0x32,0x30,0x31,0x33
	.DB  0x20,0x0,0x4A,0x6F,0x75,0x72,0x0,0x4E
	.DB  0x75,0x69,0x74,0x0,0x4D,0x65,0x73,0x75
	.DB  0x72,0x65,0x20,0x25,0x2D,0x69,0x20,0x25
	.DB  0x2D,0x63,0x20,0x54,0x65,0x6D,0x70,0x45
	.DB  0x78,0x74,0x3D,0x25,0x2D,0x69,0x2E,0x25
	.DB  0x2D,0x75,0x43,0x20,0x25,0x2D,0x63,0x20
	.DB  0x54,0x65,0x6D,0x70,0x49,0x6E,0x74,0x3D
	.DB  0x25,0x2D,0x73,0x43,0x20,0x25,0x2D,0x63
	.DB  0x20,0x48,0x75,0x6D,0x3D,0x25,0x2D,0x73
	.DB  0x25,0x2D,0x63,0x20,0x25,0x2D,0x63,0x20
	.DB  0x25,0x2D,0x73,0x20,0x25,0x2D,0x63,0x20
	.DB  0x50,0x3D,0x25,0x2D,0x73,0x0,0x5B,0x32
	.DB  0x31,0x5D,0x20,0x25,0x2D,0x75,0x2F,0x25
	.DB  0x2D,0x75,0x2F,0x25,0x2D,0x69,0x0,0x20
	.DB  0x20,0x25,0x2D,0x75,0x68,0x2F,0x25,0x2D
	.DB  0x75,0x6D,0x6E,0x2F,0x25,0x2D,0x75,0x73
	.DB  0x0,0x5B,0x32,0x32,0x5D,0x20,0x20,0x20
	.DB  0x52,0x48,0x3D,0x25,0x2D,0x73,0x25,0x2D
	.DB  0x63,0x0,0x45,0x3D,0x25,0x2D,0x69,0x2E
	.DB  0x25,0x2D,0x75,0x25,0x2D,0x63,0x20,0x49
	.DB  0x3D,0x25,0x2D,0x73,0x25,0x2D,0x63,0x0
	.DB  0x53,0x6E,0x3D,0x25,0x2D,0x73,0x25,0x2D
	.DB  0x63,0x20,0x54,0x3D,0x25,0x2D,0x73,0x25
	.DB  0x2D,0x63,0x0,0x53,0x78,0x3D,0x25,0x2D
	.DB  0x73,0x25,0x2D,0x63,0x20,0x50,0x3D,0x25
	.DB  0x2D,0x75,0x25,0x2D,0x63,0x0,0x52,0x61
	.DB  0x70,0x2E,0x20,0x63,0x79,0x63,0x6C,0x20
	.DB  0x3D,0x20,0x25,0x2D,0x75,0x25,0x25,0x0
	.DB  0x43,0x64,0x65,0x20,0x56,0x65,0x6E,0x74
	.DB  0x69,0x6C,0x61,0x2E,0x20,0x3D,0x20,0x25
	.DB  0x2D,0x75,0x0,0x53,0x65,0x72,0x76,0x6F
	.DB  0x3A,0x20,0x74,0x31,0x3D,0x25,0x2D,0x75
	.DB  0x75,0x73,0x0
_0x2020060:
	.DB  0x1
_0x2020000:
	.DB  0x2D,0x4E,0x41,0x4E,0x0,0x49,0x4E,0x46
	.DB  0x0
_0x2040003:
	.DB  0x1
_0x2040000:
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x6D,0x6E,0x20,0x45,0x3E,0x53
	.DB  0x0,0x68,0x3A,0x20,0x25,0x2D,0x75,0x68
	.DB  0x2F,0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25
	.DB  0x2D,0x75,0x73,0x20,0x0,0x49,0x3E,0x2B
	.DB  0x20,0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4D
	.DB  0x20,0x45,0x3E,0x53,0x0,0x4A,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x69,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x73,0x20
	.DB  0x45,0x3E,0x53,0x0,0x6D,0x6E,0x3A,0x20
	.DB  0x25,0x2D,0x75,0x68,0x2F,0x25,0x2D,0x75
	.DB  0x6D,0x6E,0x2F,0x25,0x2D,0x75,0x73,0x20
	.DB  0x0,0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D
	.DB  0x20,0x4F,0x3E,0x41,0x20,0x45,0x3E,0x53
	.DB  0x0,0x4D,0x3A,0x20,0x25,0x2D,0x75,0x2F
	.DB  0x25,0x2D,0x75,0x2F,0x25,0x2D,0x69,0x0
	.DB  0x49,0x3E,0x2B,0x20,0x44,0x3E,0x2D,0x20
	.DB  0x4F,0x3E,0x68,0x20,0x45,0x3E,0x53,0x0
	.DB  0x73,0x3A,0x20,0x25,0x2D,0x75,0x68,0x2F
	.DB  0x25,0x2D,0x75,0x6D,0x6E,0x2F,0x25,0x2D
	.DB  0x75,0x73,0x20,0x0,0x49,0x3E,0x2B,0x20
	.DB  0x44,0x3E,0x2D,0x20,0x4F,0x3E,0x4A,0x20
	.DB  0x45,0x3E,0x53,0x0,0x41,0x3A,0x20,0x25
	.DB  0x2D,0x75,0x2F,0x25,0x2D,0x75,0x2F,0x25
	.DB  0x2D,0x69,0x0
_0x20C0003:
	.DB  0x80,0xC0

__GLOBAL_INI_TBL:
	.DW  0x01
	.DW  0x02
	.DW  __REG_BIT_VARS*2

	.DW  0x01
	.DW  __seed_G101
	.DW  _0x2020060*2

	.DW  0x01
	.DW  _Etat_BP_I2C_S1020000000
	.DW  _0x2040003*2

	.DW  0x02
	.DW  __base_y_G106
	.DW  _0x20C0003*2

_0xFFFFFFFF:
	.DW  0

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,(14-2)+1
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(__CLEAR_SRAM_SIZE)
	LDI  R25,HIGH(__CLEAR_SRAM_SIZE)
	LDI  R26,__SRAM_START
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;HARDWARE STACK POINTER INITIALIZATION
	LDI  R30,LOW(__SRAM_END-__HEAP_SIZE)
	OUT  SPL,R30
	LDI  R30,HIGH(__SRAM_END-__HEAP_SIZE)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(__SRAM_START+__DSTACK_SIZE)
	LDI  R29,HIGH(__SRAM_START+__DSTACK_SIZE)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260

	.CSEG
;/****************************************************************
;Project : PPE SERRE
;Version : 1
;// --------------------------------------------------------------
;Fichier source : SERREFIN.c
;Date de  cration : 15/12/2010
;Mise  jour le : 09/03/2012
;// --------------------------------------------------------------
;Author  : Philippe Mariano
;Company : Lyce Pierre Emile Martin 18000 BOURGES
;// --------------------------------------------------------------
;Comments: PPE SERRE
;// --------------------------------------------------------------
;Cross compilateur: CVAVR V2.04.08a Standard
;// --------------------------------------------------------------
;// Cible hardware : Carte SISI (I2C soft)
;// --------------------------------------------------------------
;Chip type           : ATmega32
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;External SRAM size  : 0
;Data Stack size     : 512
;****************************************************************/
;//===============================================================================================================
;// Bibliothques
;//---------------------------------------------------------------------------------------------------------------
;// CVAVR
;//---------------------------------------------------------------------------------------------------------------
;#include <mega32.h>
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
;//---------------------------------------------------------------------------------------------------------------
;#include <stdio.h>      // contient la fonction sprintf
;#include <delay.h>      // contient la fonction delay_ms
;#include <stdlib.h> 	// contient la fonction abs()
;//---------------------------------------------------------------------------------------------------------------
;// Bibliothques dveloppes pour la carte SISI
;//---------------------------------------------------------------------------------------------------------------
;#include "SISI2.h"          // Contient les fonctions: Lire_BP_I2C_Soft, Affiche_LCD, Arret_Moteurs,
;                            // Active_Moteurs, Affiche_Fleche, RegleHTR
;#include "PCF8574.h"        // Contient les fonctions: Ecrire_Port_I2C_Soft, Lire_Port_I2C_Soft
;//===============================================================================================================
;// I2C Bus functions
;#asm
   .equ __i2c_port=0x18 ;PORTB
   .equ __sda_bit=1
   .equ __scl_bit=0
; 0000 002F #endasm
;#include <i2c.h>
;//---------------------------------------------------------------------------------------------------------------
;// DS1621 Thermometer/Thermostat functions
;#include <ds1621.h>
;
;// PCF8583 Real Time Clock functions
;#include <pcf8583.h>
;//---------------------------------------------------------------------------------------------------------------
;// Alphanumeric LCD Module functions
;#asm
   .equ __lcd_port=0x15 ;PORTC
; 0000 003B #endasm
;#include <lcd.h>
; //--------------------------------------------------------------------------------------------------------------
;// #include <alcd.h>   // PB avec biblio SSI2 !
;//---------------------------------------------------------------------------------------------------------------
;#define ADC_VREF_TYPE 0x20
;//===============================================================================================================
;
;//===============================================================================================================
;// Dclarations
;//---------------------------------------------------------------------------------------------------------------
;// Etats du graphe des menus
;//---------------------------------------------------------------------------------------------------------------
;#define ReglerHTR                   0
;#define Afficher                    1
;#define Tester                      2
;#define Simuler                     3
;#define Reguler                     4
;#define AfficherHorloge             5
;#define AfficherMesures             6
;#define TesterChauffage             7
;#define TesterVentilation           8
;#define TesterTrappes               9
;#define CommanderChauffageManu      10
;#define CommanderVentilationManu    11
;#define CommanderTrappesManu        12
;#define RegulationTOR               14
;
;//---------------------------------------------------------------------------------------------------------------
;// Symboles LCD personaliss
;//---------------------------------------------------------------------------------------------------------------
;#define FlecheH                     0
;#define FlecheB                     1
;#define Soleil                      2
;#define Lune                        3
;//---------------------------------------------------------------------------------------------------------------
;// Adresse HTR
;//---------------------------------------------------------------------------------------------------------------
;#define AdresseHTR                  0
;//---------------------------------------------------------------------------------------------------------------
;// Entres du CAN
;//---------------------------------------------------------------------------------------------------------------
;#define EntreeHumidite              6
;#define EntreeTemperatureSerre      5
;#define EntreeLuminositee           0
;//---------------------------------------------------------------------------------------------------------------
;// Sorties PWM
;//---------------------------------------------------------------------------------------------------------------
;#define PWMChauffage                OCR1B
;#define PWMTrappes                  PORTD.7
;#define TORVentilation              PORTD.5
;//---------------------------------------------------------------------------------------------------------------
;// Visualisations sur les leds de la carte SISI
;#define LedsEteintes                0b11111111
;#define VisuCdeChauffage            0b01111111
;#define VisuCdeVentilation          0b10111111
;#define VisuCdeTrappes              0b11011111
;#define VisuLectureTemps            0b11111110
;#define VisuLectureTempInt          0b11111101
;#define VisuLectureTempExt          0b11111011
;#define VisuLectureHumid            0b11110111
;#define VisuLectureLum              0b11101111
;//---------------------------------------------------------------------------------------------------------------
;// Rglage de l'HTR par dfaut
;//---------------------------------------------------------------------------------------------------------------
;#define   ChoixHeure                0
;#define   ChoixDate                 1
;#define   DefautHeure               12
;#define   DefautMinute              30
;#define   DefautSeconde             0
;#define   DefautAnnee               2013
;#define   DefautMois                6
;#define   DefautJour                15
;//===============================================================================================================
;
;//===============================================================================================================
;// Read the 8 most significant bits
;// of the AD conversion result
;unsigned char read_adc(unsigned char adc_input)
; 0000 008A {

	.CSEG
_read_adc:
; 0000 008B ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	ORI  R30,0x20
	OUT  0x7,R30
; 0000 008C // Delay needed for the stabilization of the ADC input voltage
; 0000 008D delay_us(10);
	__DELAY_USB 27
; 0000 008E // Start the AD conversion
; 0000 008F ADCSRA|=0x40;
	SBI  0x6,6
; 0000 0090 // Wait for the AD conversion to complete
; 0000 0091 while ((ADCSRA & 0x10)==0);
_0x3:
	SBIS 0x6,4
	RJMP _0x3
; 0000 0092 ADCSRA|=0x10;
	SBI  0x6,4
; 0000 0093 return ADCH;
	IN   R30,0x5
	ADIW R28,1
	RET
; 0000 0094 }
;// ==============================================================================================================
;
;// ==============================================================================================================
;//---------------------------------------------------------------------------------------------------------------
;// Declare your global variables here
;//---------------------------------------------------------------------------------------------------------------
;// Type 		            Nom 				       		 Description
;//---------------------------------------------------------------------------------------------------------------
;bit AfficheMenuReglageHTR = 0;                         //  Gestion de l'affichage
;bit PremierReglageHeureHTR = 1;
;bit PremierReglageDateHTR = 1;
;//---------------------------------------------------------------------------------------------------------------
;// Constantes en flash
;//---------------------------------------------------------------------------------------------------------------
;flash char TexteMenuAcquiter[]      = "         [ENTR] ";
;flash char TexteMenuAcquitQuitter[] = " [ENTR] [ECHAP] ";
;flash char TexteMenuReglerHTR[]     = "[1] Reglage HTR ";
;flash char TexteMenusAfficher[]	    = "[2] Affichages  ";
;flash char TexteMenusTester[]       = "[3] Tests       ";
;flash char TexteMenuRegulerTOR[]    = "[4] Regul. TOR  ";
;flash char TexteMenuHeureOuDate[]   = " SET>H ETR>Date ";
;flash char TexteMenuPlusMoinsEsc[]  = "[+] [-] [ECHAP] ";
;flash char TexteSousMenuChauffage[]     = "[31] Test Chauf ";
;flash char TexteSousMenuVentilation[]   = "[32] Test Vent. ";
;flash char TexteSousMenuTrappes[]       = "[33] Test Trap. ";
;//---------------------------------------------------------------------------------------------------------------
;// Tables des caractres personnaliss:  placer dans la mmoire CGRAM du LCD (8 caractres maxi)
;//---------------------------------------------------------------------------------------------------------------
;flash unsigned char IconeFlecheHaut[] = {0x04, 0x0E, 0x15, 0x04, 0x04, 0x04, 0x04, 0x00};   // @1 CGRAM
;flash unsigned char IconeFlecheBas[]  = {0x04, 0x04, 0x04, 0x04, 0x15, 0x0E, 0x04, 0x00};   // @2 CGRAM
;flash unsigned char IconeJour[]       = {0x04, 0x0A, 0x11, 0x04, 0x11, 0x0A, 0x04, 0x00};   // @3 CGRAM
;flash unsigned char IconeNuit[]       = {0x00, 0x06, 0x07, 0x07, 0x07, 0x06, 0x00, 0x00};   // @4 CGRAM
;// ==============================================================================================================
;
;// ==============================================================================================================
;// Prototypes des fonctions en cours de test
;//---------------------------------------------------------------------------------------------------------------
;void AfficheCaracterePersoSurLCD(unsigned char numero, unsigned char posColonne, unsigned char posLigne);
;unsigned char ReglagePWMServo(unsigned int Reglaget1Servo);
;// ==============================================================================================================
;
;// ==============================================================================================================
;// ==============================================================================================================
;void main(void)
; 0000 00C1 {
_main:
; 0000 00C2 // ==============================================================================================================
; 0000 00C3 // Declare your local variables here
; 0000 00C4 //---------------------------------------------------------------------------------------------------------------
; 0000 00C5 // Type 		            Nom 				       		 Description
; 0000 00C6 //---------------------------------------------------------------------------------------------------------------
; 0000 00C7 // Liaison srie SISI -> PC
; 0000 00C8 char TrameRS232Mesures[70];                                             // Tableau des mesures  afficher sur le PC
; 0000 00C9 unsigned int NumeroMesure = 0;
; 0000 00CA //---------------------------------------------------------------------------------------------------------------
; 0000 00CB // Afficheur LCD  processeur Hitachi
; 0000 00CC char display_buffer_ligne0[17]; 				                        // Buffer ligne 0 de l'afficheur
; 0000 00CD char display_buffer_ligne1[17]; 	       	       		                // Buffer ligne 1 de l'afficheur
; 0000 00CE //---------------------------------------------------------------------------------------------------------------
; 0000 00CF // HTR
; 0000 00D0 unsigned char Jour, Mois = 0;                                           // Date de la HTR
; 0000 00D1 unsigned int Annee = 0;
; 0000 00D2 unsigned char Heures = 0, Minutes = 0, Secondes_n = 0, Dizieme = 0;     // Heure de la HTR
; 0000 00D3 unsigned char Secondes_n_1 = 0, Secondes_n_1H = 0; 	                    // Assure la stabilit de l'affichage
; 0000 00D4 //---------------------------------------------------------------------------------------------------------------
; 0000 00D5 // BP de la carte SSI
; 0000 00D6 unsigned char BP = 0; // Code_BP = 0;
; 0000 00D7 //---------------------------------------------------------------------------------------------------------------
; 0000 00D8 // Graphe des transitions des menus
; 0000 00D9 unsigned char EtatMenu = ReglerHTR, EtatMenu_1 = AfficherHorloge;
; 0000 00DA //---------------------------------------------------------------------------------------------------------------
; 0000 00DB // Grandeurs physiques
; 0000 00DC //---------------------------------------------------------------------------------------------------------------
; 0000 00DD // Temps
; 0000 00DE unsigned char DeltaTemps;
; 0000 00DF //---------------------------------------------------------------------------------------------------------------
; 0000 00E0 // Humidit
; 0000 00E1 unsigned char UHumidite = 0;     			// Image de la tension fournie par le capteurl'humidit [0, 255]
; 0000 00E2 float RH_n = 0, RH_n_1 = 0;				    // Valeur de l'humidit calcule [0, 100%]
; 0000 00E3 //---------------------------------------------------------------------------------------------------------------
; 0000 00E4 // Temprature
; 0000 00E5 unsigned char UTemperatureInterieure = 0;   // Image de la tension dlivre par la sonde PT100
; 0000 00E6 unsigned int TemperatureExterieure_n_1 = 0, TemperatureExterieure_n = 0;   // Valeur de la temprature extrieure
; 0000 00E7 float SeuilTempIntSimuleMin = 21.5, SeuilTempIntSimuleMax = 22.5;
; 0000 00E8 float TemperatureInterieure_n = 0, TemperatureInterieure_n_1 = 0;
; 0000 00E9 //---------------------------------------------------------------------------------------------------------------
; 0000 00EA // Luminosit
; 0000 00EB unsigned char Luminosite = 0;               // Image de la Luminosit [0,255]
; 0000 00EC unsigned char JourOuNuit_n_1 = 0, JourOuNuit_n = 1;
; 0000 00ED //---------------------------------------------------------------------------------------------------------------
; 0000 00EE // Chanes de caractres pour l'affichage des grandeurs physiques
; 0000 00EF unsigned char ChaineHumidite[]="00.0";
; 0000 00F0 unsigned char ChaineJourNuit[]="Jour";
; 0000 00F1 unsigned char ChaineTemperatureInterieure[]="00.0";
; 0000 00F2 unsigned char ChaineSeuilTempIntSimuleMin[]="00.0";
; 0000 00F3 unsigned char ChaineSeuilTempIntSimuleMax[]="00.0";
; 0000 00F4 unsigned char ChaineCdeChauffage[]="000";
; 0000 00F5 //---------------------------------------------------------------------------------------------------------------
; 0000 00F6 // Compteurs associs  la mesure des grandeurs physiques
; 0000 00F7 unsigned int CompteurMesureTemperatureExterieure = 0;
; 0000 00F8 unsigned int CompteurMesureTemperatureInterieure = 0;
; 0000 00F9 unsigned int CompteurMesureHumidite = 0;
; 0000 00FA unsigned int CompteurMesureLuminosite = 0;
; 0000 00FB unsigned int CompteurTxRS232 = 0;
; 0000 00FC //---------------------------------------------------------------------------------------------------------------
; 0000 00FD // Timer
; 0000 00FE unsigned char rcycl=0, rcycl_1=0;               // Consigne de rapport cyclique
; 0000 00FF // Table des coefficients pour le rglage du rapport cyclique du signal PWMChauffage (F = 3,8Hz)
; 0000 0100 unsigned int alphaChauffage[11] = {0,100,204,304,408,508,612,712,816,916,1023};
; 0000 0101 //---------------------------------------------------------------------------------------------------------------
; 0000 0102 // Commande TOR
; 0000 0103 unsigned char TORVentilation_1 = 1;
; 0000 0104 unsigned int t1Servo = 0, t1Servo_1 = 1;
; 0000 0105 unsigned char CommandeChauffage = 0;
; 0000 0106 //---------------------------------------------------------------------------------------------------------------
; 0000 0107 // Divers
; 0000 0108 unsigned char i=0;                             // Compteur de boucle
; 0000 0109 //---------------------------------------------------------------------------------------------------------------
; 0000 010A // Constantes
; 0000 010B //---------------------------------------------------------------------------------------------------------------
; 0000 010C // ==============================================================================================================
; 0000 010D // Initialisation des priphriques
; 0000 010E //---------------------------------------------------------------------------------------------------------------
; 0000 010F // Port D initialization
; 0000 0110 // Func7=Out Func6=In Func5=Out Func4=Out Func3=In Func2=In Func1=In Func0=In
; 0000 0111 // State7=0 State6=T State5=0 State4=0 State3=T State2=T State1=T State0=T
; 0000 0112 PORTD=0x00;
	SBIW R28,63
	SBIW R28,63
	SBIW R28,63
	SBIW R28,28
	LDI  R24,113
	LDI  R26,LOW(0)
	LDI  R27,HIGH(0)
	LDI  R30,LOW(_0x6*2)
	LDI  R31,HIGH(_0x6*2)
	CALL __INITLOCB
;	TrameRS232Mesures -> Y+147
;	NumeroMesure -> R16,R17
;	display_buffer_ligne0 -> Y+130
;	display_buffer_ligne1 -> Y+113
;	Jour -> R19
;	Mois -> R18
;	Annee -> R20,R21
;	Heures -> Y+112
;	Minutes -> Y+111
;	Secondes_n -> Y+110
;	Dizieme -> Y+109
;	Secondes_n_1 -> Y+108
;	Secondes_n_1H -> Y+107
;	BP -> Y+106
;	EtatMenu -> Y+105
;	EtatMenu_1 -> Y+104
;	DeltaTemps -> Y+103
;	UHumidite -> Y+102
;	RH_n -> Y+98
;	RH_n_1 -> Y+94
;	UTemperatureInterieure -> Y+93
;	TemperatureExterieure_n_1 -> Y+91
;	TemperatureExterieure_n -> Y+89
;	SeuilTempIntSimuleMin -> Y+85
;	SeuilTempIntSimuleMax -> Y+81
;	TemperatureInterieure_n -> Y+77
;	TemperatureInterieure_n_1 -> Y+73
;	Luminosite -> Y+72
;	JourOuNuit_n_1 -> Y+71
;	JourOuNuit_n -> Y+70
;	ChaineHumidite -> Y+65
;	ChaineJourNuit -> Y+60
;	ChaineTemperatureInterieure -> Y+55
;	ChaineSeuilTempIntSimuleMin -> Y+50
;	ChaineSeuilTempIntSimuleMax -> Y+45
;	ChaineCdeChauffage -> Y+41
;	CompteurMesureTemperatureExterieure -> Y+39
;	CompteurMesureTemperatureInterieure -> Y+37
;	CompteurMesureHumidite -> Y+35
;	CompteurMesureLuminosite -> Y+33
;	CompteurTxRS232 -> Y+31
;	rcycl -> Y+30
;	rcycl_1 -> Y+29
;	alphaChauffage -> Y+7
;	TORVentilation_1 -> Y+6
;	t1Servo -> Y+4
;	t1Servo_1 -> Y+2
;	CommandeChauffage -> Y+1
;	i -> Y+0
	__GETWRN 16,17,0
	LDI  R18,0
	__GETWRN 20,21,0
	LDI  R30,LOW(0)
	OUT  0x12,R30
; 0000 0113 DDRD=0x10; //0xB0
	LDI  R30,LOW(16)
	OUT  0x11,R30
; 0000 0114 //---------------------------------------------------------------------------------------------------------------
; 0000 0115 // Timer/Counter 1 initialization
; 0000 0116 // Clock source: System Clock
; 0000 0117 // Clock value: 7,813 kHz
; 0000 0118 // Mode: Ph. correct PWM top=03FFh
; 0000 0119 // OC1A output: Discon.
; 0000 011A // OC1B output: Non-Inv.
; 0000 011B // Noise Canceler: Off
; 0000 011C // Input Capture on Falling Edge
; 0000 011D // Timer1 Overflow Interrupt: Off
; 0000 011E // Input Capture Interrupt: Off
; 0000 011F // Compare A Match Interrupt: Off
; 0000 0120 // Compare B Match Interrupt: Off
; 0000 0121 TCCR1A=0x23;
	LDI  R30,LOW(35)
	OUT  0x2F,R30
; 0000 0122 TCCR1B=0x05;
	LDI  R30,LOW(5)
	OUT  0x2E,R30
; 0000 0123 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
; 0000 0124 TCNT1L=0x00;
	OUT  0x2C,R30
; 0000 0125 ICR1H=0x00;
	OUT  0x27,R30
; 0000 0126 
; 0000 0127 ICR1L=0x00;
	OUT  0x26,R30
; 0000 0128 OCR1AH=0x00;
	OUT  0x2B,R30
; 0000 0129 OCR1AL=0x00;
	OUT  0x2A,R30
; 0000 012A OCR1BH=0x00;
	OUT  0x29,R30
; 0000 012B OCR1BL=0x00;
	OUT  0x28,R30
; 0000 012C //---------------------------------------------------------------------------------------------------------------
; 0000 012D // ADC initialization
; 0000 012E // ADC Clock frequency: 62,500 kHz
; 0000 012F // ADC Voltage Reference: AREF pin
; 0000 0130 // ADC High Speed Mode: Off
; 0000 0131 // ADC Auto Trigger Source: ADC Stopped
; 0000 0132 // Only the 8 most significant bits of
; 0000 0133 // the AD conversion result are used
; 0000 0134 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(32)
	OUT  0x7,R30
; 0000 0135 ADCSRA=0x87;
	LDI  R30,LOW(135)
	OUT  0x6,R30
; 0000 0136 SFIOR&=0xEF;
	IN   R30,0x30
	ANDI R30,0xEF
	OUT  0x30,R30
; 0000 0137 //---------------------------------------------------------------------------------------------------------------
; 0000 0138 // USART initialization
; 0000 0139 // Communication Parameters: 8 Data, 1 Stop, No Parity
; 0000 013A // USART Receiver: Off
; 0000 013B // USART Transmitter: On
; 0000 013C // USART Mode: Asynchronous
; 0000 013D // USART Baud Rate: 9600
; 0000 013E UCSRA=0x00;
	LDI  R30,LOW(0)
	OUT  0xB,R30
; 0000 013F UCSRB=0x08;
	LDI  R30,LOW(8)
	OUT  0xA,R30
; 0000 0140 UCSRC=0x86;
	LDI  R30,LOW(134)
	OUT  0x20,R30
; 0000 0141 UBRRH=0x00;
	LDI  R30,LOW(0)
	OUT  0x20,R30
; 0000 0142 UBRRL=0x33;
	LDI  R30,LOW(51)
	OUT  0x9,R30
; 0000 0143 //---------------------------------------------------------------------------------------------------------------
; 0000 0144 // I2C Bus initialization
; 0000 0145 i2c_init();
	CALL _i2c_init
; 0000 0146 //---------------------------------------------------------------------------------------------------------------
; 0000 0147 // DS1621 Thermometer/Thermostat initialization
; 0000 0148 // tlow: 50C
; 0000 0149 // thigh: 55C
; 0000 014A // Tout polarity: 0
; 0000 014B ds1621_init(0,50,55,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(55)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _ds1621_init
; 0000 014C //---------------------------------------------------------------------------------------------------------------
; 0000 014D // PCF8583 Real Time Clock initialization
; 0000 014E rtc_init(0,0);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	CALL _rtc_init
; 0000 014F //---------------------------------------------------------------------------------------------------------------
; 0000 0150 // Alphanumeric LCD initialization
; 0000 0151 // Connections specified in the
; 0000 0152 // Project|Configure|C Compiler|Libraries|Alphanumeric LCD menu:
; 0000 0153 // RS - PORTC Bit 0
; 0000 0154 // RD - PORTC Bit 1
; 0000 0155 // EN - PORTC Bit 2
; 0000 0156 // D4 - PORTC Bit 4
; 0000 0157 // D5 - PORTC Bit 5
; 0000 0158 // D6 - PORTC Bit 6
; 0000 0159 // D7 - PORTC Bit 7
; 0000 015A // Characters/line: 16
; 0000 015B lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
; 0000 015C //------------------------------------------------------------------------------------------------------------
; 0000 015D // Chargement de la mmoire CGRAM de l'afficheur avec les caractres personaliss
; 0000 015E //------------------------------------------------------------------------------------------------------------
; 0000 015F for (i=0;i<8;i++)
	LDI  R30,LOW(0)
	ST   Y,R30
_0x8:
	LD   R26,Y
	CPI  R26,LOW(0x8)
	BRSH _0x9
; 0000 0160 {
; 0000 0161  lcd_write_byte(Add_Base_CGRAM + i, IconeFlecheHaut[i]);            // Caractre 0 flche haut
	LD   R30,Y
	SUBI R30,-LOW(64)
	ST   -Y,R30
	LDD  R30,Y+1
	LDI  R31,0
	SUBI R30,LOW(-_IconeFlecheHaut*2)
	SBCI R31,HIGH(-_IconeFlecheHaut*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
; 0000 0162  lcd_write_byte(Add_Base_CGRAM + 8 + i, IconeFlecheBas[i]);         // Caractre 1 flche bas
	LD   R30,Y
	SUBI R30,-LOW(72)
	ST   -Y,R30
	LDD  R30,Y+1
	LDI  R31,0
	SUBI R30,LOW(-_IconeFlecheBas*2)
	SBCI R31,HIGH(-_IconeFlecheBas*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
; 0000 0163  lcd_write_byte(Add_Base_CGRAM + 16 + i, IconeJour[i]);             // Caractre 2 Jour
	LD   R30,Y
	SUBI R30,-LOW(80)
	ST   -Y,R30
	LDD  R30,Y+1
	LDI  R31,0
	SUBI R30,LOW(-_IconeJour*2)
	SBCI R31,HIGH(-_IconeJour*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
; 0000 0164  lcd_write_byte(Add_Base_CGRAM + 24 + i, IconeNuit[i]);             // Caractre 3 Nuit
	LD   R30,Y
	SUBI R30,-LOW(88)
	ST   -Y,R30
	LDD  R30,Y+1
	LDI  R31,0
	SUBI R30,LOW(-_IconeNuit*2)
	SBCI R31,HIGH(-_IconeNuit*2)
	LPM  R30,Z
	ST   -Y,R30
	CALL _lcd_write_byte
; 0000 0165 }
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RJMP _0x8
_0x9:
; 0000 0166 //------------------------------------------------------------------------------------------------------------
; 0000 0167 // ==============================================================================================================
; 0000 0168 // Message d'accueil
; 0000 0169 //---------------------------------------------------------------------------------------------------------------
; 0000 016A sprintf(display_buffer_ligne0," PPE SERRE SISI ");
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 016B sprintf(display_buffer_ligne1," Maj:01/12/2013 ");
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 016C Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 016D // Initialisation des seuils de temprature
; 0000 016E ftoa(SeuilTempIntSimuleMin,1,ChaineSeuilTempIntSimuleMin);
	__GETD1SX 85
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,55
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 016F ftoa(SeuilTempIntSimuleMax,1,ChaineSeuilTempIntSimuleMax);
	__GETD1SX 81
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,50
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 0170 delay_ms(5000);
	LDI  R30,LOW(5000)
	LDI  R31,HIGH(5000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 0171 
; 0000 0172 // ==============================================================================================================
; 0000 0173 // ==============================================================================================================
; 0000 0174 // Boucle principale
; 0000 0175 // ==============================================================================================================
; 0000 0176 // ==============================================================================================================
; 0000 0177 //---------------------------------------------------------------------------------------------------------------
; 0000 0178 while (1)
_0xA:
; 0000 0179  {
; 0000 017A // ==============================================================================================================
; 0000 017B // Dbut acqurir
; 0000 017C //---------------------------------------------------------------------------------------------------------------
; 0000 017D // Lecture du clavier, de l'heure, de la temprature intrieure et extrieure  la serre, de l'humidit intrieure
; 0000 017E //  la serre et de la luminosit
; 0000 017F //---------------------------------------------------------------------------------------------------------------
; 0000 0180     BP = Lire_BP_I2C_Soft();                            // Lecture BP pour volution du graphe des menus
	CALL _Lire_BP_I2C_Soft
	__PUTB1SX 106
; 0000 0181                                                         // Avec gestion anti-rebonds
; 0000 0182     //Code_BP =  Lire_Port_I2C_Soft(Add_BP_I2C);          // Lecture BP pour affichage sur les LED
; 0000 0183                                                         // Code BP = Code LED
; 0000 0184  //---------------------------------------------------------------------------------------------------------------
; 0000 0185  // Lecture HTR
; 0000 0186     rtc_get_time(AdresseHTR,&Heures,&Minutes,&Secondes_n,&Dizieme);
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(114))
	SBCI R31,HIGH(-(114))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(116))
	SBCI R31,HIGH(-(116))
	ST   -Y,R31
	ST   -Y,R30
	CALL _rtc_get_time
; 0000 0187 
; 0000 0188  // Rfrence de temps pour la mesure des grandeurs physiques
; 0000 0189     if (Secondes_n_1 < Secondes_n)
	__GETB1SX 110
	__GETB2SX 108
	CP   R26,R30
	BRSH _0xD
; 0000 018A                 DeltaTemps = Secondes_n - Secondes_n_1;
	__GETB2SX 110
	CLR  R27
	__GETB1SX 108
	LDI  R31,0
	CALL __SWAPW12
	SUB  R30,R26
	RJMP _0xC5
; 0000 018B     else if (Secondes_n_1 > Secondes_n)
_0xD:
	__GETB1SX 110
	__GETB2SX 108
	CP   R30,R26
	BRSH _0xF
; 0000 018C                 DeltaTemps = (59 - Secondes_n) + Secondes_n_1;
	LDI  R31,0
	LDI  R26,LOW(59)
	LDI  R27,HIGH(59)
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	__GETB2SX 108
	ADD  R30,R26
	RJMP _0xC5
; 0000 018D     else
_0xF:
; 0000 018E                 DeltaTemps = 0;
	LDI  R30,LOW(0)
_0xC5:
	__PUTB1SX 103
; 0000 018F 
; 0000 0190     if (DeltaTemps != 0)
	CPI  R30,0
	BRNE PC+3
	JMP _0x11
; 0000 0191      {
; 0000 0192         // Mise  jour des compteurs associs aux mesures
; 0000 0193         CompteurMesureTemperatureExterieure = CompteurMesureTemperatureExterieure + DeltaTemps;
	LDI  R31,0
	LDD  R26,Y+39
	LDD  R27,Y+39+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+39,R30
	STD  Y+39+1,R31
; 0000 0194         CompteurMesureTemperatureInterieure = CompteurMesureTemperatureInterieure + DeltaTemps;
	__GETB1SX 103
	LDI  R31,0
	LDD  R26,Y+37
	LDD  R27,Y+37+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+37,R30
	STD  Y+37+1,R31
; 0000 0195         CompteurMesureHumidite = CompteurMesureHumidite + DeltaTemps;
	__GETB1SX 103
	LDI  R31,0
	LDD  R26,Y+35
	LDD  R27,Y+35+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+35,R30
	STD  Y+35+1,R31
; 0000 0196         CompteurMesureLuminosite = CompteurMesureLuminosite + DeltaTemps;
	__GETB1SX 103
	LDI  R31,0
	LDD  R26,Y+33
	LDD  R27,Y+33+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+33,R30
	STD  Y+33+1,R31
; 0000 0197         CompteurTxRS232 = CompteurTxRS232 + DeltaTemps;
	__GETB1SX 103
	LDI  R31,0
	LDD  R26,Y+31
	LDD  R27,Y+31+1
	ADD  R30,R26
	ADC  R31,R27
	STD  Y+31,R30
	STD  Y+31+1,R31
; 0000 0198         Secondes_n_1 = Secondes_n;
	__GETB1SX 110
	__PUTB1SX 108
; 0000 0199         // Visualisation de la lecture de l'HTR sur la Led D0
; 0000 019A         Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuLectureTemps); // Visualisation de la prise de mesure
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(254)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 019B         delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 019C         Ecrire_Port_I2C_Soft(Add_LED_I2C,LedsEteintes);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 019D //---------------------------------------------------------------------------------------------------------------
; 0000 019E // Acquisition de la temprature extrieure  la serre
; 0000 019F         if (CompteurMesureTemperatureExterieure >= 5)   // A rgler pour mesure de la temprature toute les 5 mn
	LDD  R26,Y+39
	LDD  R27,Y+39+1
	SBIW R26,5
	BRLO _0x12
; 0000 01A0             {
; 0000 01A1                 TemperatureExterieure_n = ds1621_temperature_10(0) - 20; // Correction =  -2C
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _ds1621_temperature_10
	SBIW R30,20
	__PUTW1SX 89
; 0000 01A2                 CompteurMesureTemperatureExterieure = 0;
	LDI  R30,LOW(0)
	STD  Y+39,R30
	STD  Y+39+1,R30
; 0000 01A3                 // Visualisation de la prise d'une mesure de la temprature extrieure sur la Led D1
; 0000 01A4                 Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuLectureTempExt);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(251)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01A5                 delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01A6                 Ecrire_Port_I2C_Soft(Add_LED_I2C,LedsEteintes);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01A7             }
; 0000 01A8 //---------------------------------------------------------------------------------------------------------------
; 0000 01A9 // Acquisition de la temprature intrieure  la serre
; 0000 01AA         if (CompteurMesureTemperatureInterieure >= 5) // A rgler
_0x12:
	LDD  R26,Y+37
	LDD  R27,Y+37+1
	SBIW R26,5
	BRLO _0x13
; 0000 01AB             {
; 0000 01AC                 UTemperatureInterieure =  read_adc(EntreeTemperatureSerre);
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _read_adc
	__PUTB1SX 93
; 0000 01AD                 TemperatureInterieure_n = (float)(UTemperatureInterieure)*0.109;//  Calcul de la temprature intrieure
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	__GETD2N 0x3DDF3B64
	CALL __MULF12
	__PUTD1SX 77
; 0000 01AE                 CompteurMesureTemperatureInterieure = 0;
	LDI  R30,LOW(0)
	STD  Y+37,R30
	STD  Y+37+1,R30
; 0000 01AF                 // Visualisation de la prise d'une mesure de la temprature intrieure sur la led D2
; 0000 01B0                 Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuLectureTempInt);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(253)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01B1                 delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01B2                 Ecrire_Port_I2C_Soft(Add_LED_I2C,LedsEteintes);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01B3             }
; 0000 01B4 //---------------------------------------------------------------------------------------------------------------
; 0000 01B5 // Acquisition de l'humidit intrieure  la serre
; 0000 01B6         if (CompteurMesureHumidite >= 10)   // Rgler la mesure d'humidit toutes les 2 mn
_0x13:
	LDD  R26,Y+35
	LDD  R27,Y+35+1
	SBIW R26,10
	BRLO _0x14
; 0000 01B7             {
; 0000 01B8                 UHumidite = read_adc(EntreeHumidite);
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _read_adc
	__PUTB1SX 102
; 0000 01B9                 RH_n =  ((float)UHumidite - 42.64)/ 1.536;   // ((UHumidite - 41(35.84))/ 1.7064); Calcul de l'humidit
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __CDF1
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x422A8F5C
	CALL __SWAPD12
	CALL __SUBF12
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x3FC49BA6
	CALL __DIVF21
	__PUTD1SX 98
; 0000 01BA                 CompteurMesureHumidite = 0;
	LDI  R30,LOW(0)
	STD  Y+35,R30
	STD  Y+35+1,R30
; 0000 01BB                 // Visualisation de la prise d'une mesure de l'humidit intrieure sur la led D3
; 0000 01BC                 Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuLectureHumid);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(247)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01BD                 delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01BE                 Ecrire_Port_I2C_Soft(Add_LED_I2C,LedsEteintes);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01BF             }
; 0000 01C0 //---------------------------------------------------------------------------------------------------------------
; 0000 01C1         // Acquisition de la luminosit
; 0000 01C2         if (CompteurMesureLuminosite >= 3)   // Rgler la mesure de la luminosit toutes les 10mn
_0x14:
	LDD  R26,Y+33
	LDD  R27,Y+33+1
	SBIW R26,3
	BRSH PC+3
	JMP _0x15
; 0000 01C3             {
; 0000 01C4                 Luminosite = read_adc(EntreeLuminositee);
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _read_adc
	__PUTB1SX 72
; 0000 01C5                 if (Luminosite >= 230)          // VPA1 > 4.5V
	__GETB2SX 72
	CPI  R26,LOW(0xE6)
	BRLO _0x16
; 0000 01C6                     {
; 0000 01C7                         JourOuNuit_n = 0;
	LDI  R30,LOW(0)
	__PUTB1SX 70
; 0000 01C8                         sprintf(ChaineJourNuit,"Jour");
	MOVW R30,R28
	ADIW R30,60
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,34
	RJMP _0xC6
; 0000 01C9                     }
; 0000 01CA                 else if (Luminosite <= 165)     // VPA1 < 3.2V
_0x16:
	__GETB2SX 72
	CPI  R26,LOW(0xA6)
	BRSH _0x18
; 0000 01CB                     {
; 0000 01CC                         JourOuNuit_n = 1;
	LDI  R30,LOW(1)
	__PUTB1SX 70
; 0000 01CD                         sprintf(ChaineJourNuit,"Nuit");
	MOVW R30,R28
	ADIW R30,60
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,39
_0xC6:
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 01CE                     }
; 0000 01CF                 CompteurMesureLuminosite = 0;
_0x18:
	LDI  R30,LOW(0)
	STD  Y+33,R30
	STD  Y+33+1,R30
; 0000 01D0                  // Visualisation de la prise d'une mesure de la luminosit sur la led D4
; 0000 01D1                 Ecrire_Port_I2C_Soft(Add_LED_I2C,VisuLectureLum); // Visualisation de la prise de mesure
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(239)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01D2                 delay_ms(50);
	LDI  R30,LOW(50)
	LDI  R31,HIGH(50)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 01D3                 Ecrire_Port_I2C_Soft(Add_LED_I2C,LedsEteintes);
	LDI  R30,LOW(64)
	ST   -Y,R30
	LDI  R30,LOW(255)
	ST   -Y,R30
	CALL _Ecrire_Port_I2C_Soft
; 0000 01D4             }
; 0000 01D5 //---------------------------------------------------------------------------------------------------------------
; 0000 01D6 // Transfert des mesures vers le PC par la liaison RS232 toutes les x secondes
; 0000 01D7 //---------------------------------------------------------------------------------------------------------------
; 0000 01D8         if (CompteurTxRS232 >= 10)  // 10s
_0x15:
	LDD  R26,Y+31
	LDD  R27,Y+31+1
	SBIW R26,10
	BRSH PC+3
	JMP _0x19
; 0000 01D9             {   // Trame des donnes transfres au PC : NMesure ; TempExt ; TempInt ; Humidit ; Luminosit
; 0000 01DA                 // Les donnes sont transfres au format CSV (sparateur point-virgule)
; 0000 01DB                 ftoa(TemperatureInterieure_n,1,ChaineTemperatureInterieure);
	__GETD1SX 77
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,60
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 01DC                 ftoa(RH_n,1,ChaineHumidite);
	__GETD1SX 98
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(70))
	SBCI R31,HIGH(-(70))
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 01DD                 itoa((int)CommandeChauffage, ChaineCdeChauffage);
	LDD  R30,Y+1
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,43
	ST   -Y,R31
	ST   -Y,R30
	CALL _itoa
; 0000 01DE                 // Affichage des mesures en clair
; 0000 01DF                 sprintf(TrameRS232Mesures,"Mesure %-i %-c TempExt=%-i.%-uC %-c TempInt=%-sC %-c Hum=%-s%-c %-c %-s %-c P=%-s",
; 0000 01E0                 // Formatage pour transfert dans un fichier
; 0000 01E1                 // sprintf(TrameRS232Mesures,"%-i%-c%-i.%-u%-c%-s%-c%-s%-c%-c%-u",
; 0000 01E2                 NumeroMesure,';',
; 0000 01E3                 TemperatureExterieure_n/10,abs(TemperatureExterieure_n%10),';',
; 0000 01E4                 ChaineTemperatureInterieure,';',
; 0000 01E5                 ChaineHumidite,'%',';',
; 0000 01E6                 ChaineJourNuit,';', ChaineCdeChauffage);
	MOVW R30,R28
	SUBI R30,LOW(-(147))
	SBCI R31,HIGH(-(147))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,44
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R16
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0x3B
	CALL __PUTPARD1
	__GETW2SX 101
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETW2SX 105
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0x3B
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(79))
	SBCI R31,HIGH(-(79))
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0x3B
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(97))
	SBCI R31,HIGH(-(97))
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0x25
	CALL __PUTPARD1
	__GETD1N 0x3B
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(104))
	SBCI R31,HIGH(-(104))
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0x3B
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(93))
	SBCI R31,HIGH(-(93))
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,52
	CALL _sprintf
	ADIW R28,56
; 0000 01E7                 //JourOuNuit_n);
; 0000 01E8                 // Remplacement des . par des , pour rendre les valeurs compatibles avec Excel
; 0000 01E9                 for(i=0;i<sizeof(TrameRS232Mesures);i++)
	LDI  R30,LOW(0)
	ST   Y,R30
_0x1B:
	LD   R26,Y
	CPI  R26,LOW(0x46)
	BRSH _0x1C
; 0000 01EA                 {
; 0000 01EB                     if (TrameRS232Mesures[i]=='.')
	LD   R30,Y
	LDI  R31,0
	MOVW R26,R28
	SUBI R26,LOW(-(147))
	SBCI R27,HIGH(-(147))
	ADD  R26,R30
	ADC  R27,R31
	LD   R26,X
	CPI  R26,LOW(0x2E)
	BRNE _0x1D
; 0000 01EC                               TrameRS232Mesures[i]=',';
	LD   R30,Y
	LDI  R31,0
	MOVW R26,R28
	SUBI R26,LOW(-(147))
	SBCI R27,HIGH(-(147))
	ADD  R26,R30
	ADC  R27,R31
	LDI  R30,LOW(44)
	ST   X,R30
; 0000 01ED                 }
_0x1D:
	LD   R30,Y
	SUBI R30,-LOW(1)
	ST   Y,R30
	RJMP _0x1B
_0x1C:
; 0000 01EE 
; 0000 01EF                 puts(TrameRS232Mesures); // Transfert sur la liaison RS232
	MOVW R30,R28
	SUBI R30,LOW(-(147))
	SBCI R31,HIGH(-(147))
	ST   -Y,R31
	ST   -Y,R30
	CALL _puts
; 0000 01F0                 putchar(0x0D); // retour  la ligne pour l'affichage sur le terminal
	LDI  R30,LOW(13)
	ST   -Y,R30
	CALL _putchar
; 0000 01F1                 NumeroMesure =  NumeroMesure + 1 ;
	__ADDWRN 16,17,1
; 0000 01F2                 CompteurTxRS232 = 0;
	LDI  R30,LOW(0)
	STD  Y+31,R30
	STD  Y+31+1,R30
; 0000 01F3             }
; 0000 01F4      }
_0x19:
; 0000 01F5 //---------------------------------------------------------------------------------------------------------------
; 0000 01F6 // Fin Acqurir
; 0000 01F7 // ==============================================================================================================
; 0000 01F8 // Dbut Traiter / Communiquer
; 0000 01F9 //---------------------------------------------------------------------------------------------------------------
; 0000 01FA // Dbut des menus
; 0000 01FB //---------------------------------------------------------------------------------------------------------------
; 0000 01FC // Menu [1] : Rglage de l'HTR
; 0000 01FD //---------------------------------------------------------------------------------------------------------------
; 0000 01FE     switch (EtatMenu)
_0x11:
	__GETB1SX 105
	LDI  R31,0
; 0000 01FF     {
; 0000 0200         case ReglerHTR : if ((EtatMenu_1 != EtatMenu) || (AfficheMenuReglageHTR))
	SBIW R30,0
	BREQ PC+3
	JMP _0x21
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BRNE _0x23
	SBRS R2,1
	RJMP _0x22
_0x23:
; 0000 0201                             {
; 0000 0202         	                    sprintf(display_buffer_ligne0,TexteMenuReglerHTR);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuReglerHTR*2)
	LDI  R31,HIGH(_TexteMenuReglerHTR*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0203         	                    sprintf(display_buffer_ligne1,TexteMenuHeureOuDate);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuHeureOuDate*2)
	LDI  R31,HIGH(_TexteMenuHeureOuDate*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0204         	                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0205                                 AfficheMenuReglageHTR = 0;
	CLT
	BLD  R2,1
; 0000 0206                                 AfficheCaracterePersoSurLCD(FlecheH,15,0);// FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0207                                 AfficheCaracterePersoSurLCD(FlecheB,15,1);// FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0208         		            }
; 0000 0209 
; 0000 020A                           switch (BP)
_0x22:
	__GETB1SX 106
	LDI  R31,0
; 0000 020B                             {
; 0000 020C                                 case SET_I2C :  if (PremierReglageHeureHTR)      // Reglage de l'heure
	CPI  R30,LOW(0x10)
	LDI  R26,HIGH(0x10)
	CPC  R31,R26
	BRNE _0x28
	SBRS R2,2
	RJMP _0x29
; 0000 020D                                             {
; 0000 020E         		  	                            RegleHTR(AdresseHTR, ChoixHeure, DefautHeure, DefautMinute, DefautSeconde);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	LDI  R30,LOW(12)
	ST   -Y,R30
	LDI  R30,LOW(30)
	ST   -Y,R30
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   -Y,R31
	ST   -Y,R30
	CALL _RegleHTR
; 0000 020F                                                 AfficheMenuReglageHTR = 1; PremierReglageHeureHTR = 0;
	SET
	BLD  R2,1
	CLT
	BLD  R2,2
; 0000 0210                                             }
; 0000 0211                                             else
	RJMP _0x2A
_0x29:
; 0000 0212                                             {
; 0000 0213         		  	                            RegleHTR(AdresseHTR, ChoixHeure, Heures, Minutes, Secondes_n);
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	__GETB1SX 114
	ST   -Y,R30
	__GETB1SX 114
	ST   -Y,R30
	__GETB1SX 114
	LDI  R31,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _RegleHTR
; 0000 0214                                                 AfficheMenuReglageHTR = 1;
	SET
	BLD  R2,1
; 0000 0215                                             }
_0x2A:
; 0000 0216                                 break;
	RJMP _0x27
; 0000 0217 
; 0000 0218         		                case ENTR_I2C : if (PremierReglageDateHTR)      // Reglage de la date
_0x28:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x2B
	SBRS R2,3
	RJMP _0x2C
; 0000 0219                                             {
; 0000 021A         		  	                            RegleHTR(AdresseHTR, ChoixDate, DefautJour, DefautMois, DefautAnnee);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDI  R30,LOW(2013)
	LDI  R31,HIGH(2013)
	ST   -Y,R31
	ST   -Y,R30
	CALL _RegleHTR
; 0000 021B                                                 AfficheMenuReglageHTR = 1; PremierReglageDateHTR = 0;
	SET
	BLD  R2,1
	CLT
	BLD  R2,3
; 0000 021C                                             }
; 0000 021D                                             else
	RJMP _0x2D
_0x2C:
; 0000 021E                                             {
; 0000 021F                                                 rtc_get_date(AdresseHTR,&Jour,&Mois,&Annee);
	LDI  R30,LOW(0)
	ST   -Y,R30
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R18
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R21
	PUSH R20
	CALL _rtc_get_date
	POP  R20
	POP  R21
	POP  R18
	POP  R19
; 0000 0220         		  	                            RegleHTR(AdresseHTR, ChoixDate, Jour, Mois, Annee);
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	ST   -Y,R19
	ST   -Y,R18
	ST   -Y,R21
	ST   -Y,R20
	CALL _RegleHTR
; 0000 0221                                                 AfficheMenuReglageHTR = 1;
	SET
	BLD  R2,1
; 0000 0222                                             }
_0x2D:
; 0000 0223                                 break;
	RJMP _0x27
; 0000 0224 
; 0000 0225                                 case FlecheB_I2C : EtatMenu = Afficher; AfficheMenuReglageHTR = 0; break;
_0x2B:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x2E
	LDI  R30,LOW(1)
	__PUTB1SX 105
	CLT
	BLD  R2,1
	RJMP _0x27
; 0000 0226 
; 0000 0227                                 case FlecheH_I2C : EtatMenu = Reguler; AfficheMenuReglageHTR = 0; break;
_0x2E:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x30
	LDI  R30,LOW(4)
	__PUTB1SX 105
	CLT
	BLD  R2,1
	RJMP _0x27
; 0000 0228 
; 0000 0229                                 default :  EtatMenu = ReglerHTR;
_0x30:
	LDI  R30,LOW(0)
	__PUTB1SX 105
; 0000 022A                             }
_0x27:
; 0000 022B 
; 0000 022C                             EtatMenu_1 = ReglerHTR;
	LDI  R30,LOW(0)
	__PUTB1SX 104
; 0000 022D          break;
	RJMP _0x20
; 0000 022E //---------------------------------------------------------------------------------------------------------------
; 0000 022F // Menu [2] : Affichages
; 0000 0230 //          [21] -> Date et heure
; 0000 0231 //          [22] -> grandeurs physiques
; 0000 0232 //---------------------------------------------------------------------------------------------------------------
; 0000 0233         case Afficher: if (EtatMenu_1 != EtatMenu)
_0x21:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x31
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BREQ _0x32
; 0000 0234                             {
; 0000 0235                                 sprintf(display_buffer_ligne0,TexteMenusAfficher);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenusAfficher*2)
	LDI  R31,HIGH(_TexteMenusAfficher*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0236         	                    sprintf(display_buffer_ligne1,TexteMenuAcquiter);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuAcquiter*2)
	LDI  R31,HIGH(_TexteMenuAcquiter*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0237         	                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0238                                 AfficheCaracterePersoSurLCD(FlecheH,15,0);// FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0239                                 AfficheCaracterePersoSurLCD(FlecheB,15,1);// FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 023A                             }
; 0000 023B 
; 0000 023C                         switch (BP)
_0x32:
	__GETB1SX 106
	LDI  R31,0
; 0000 023D                             {
; 0000 023E                                 case FlecheB_I2C: EtatMenu = Tester; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x36
	LDI  R30,LOW(2)
	RJMP _0xC7
; 0000 023F                                 case FlecheH_I2C: EtatMenu = ReglerHTR; break;
_0x36:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x37
	LDI  R30,LOW(0)
	RJMP _0xC7
; 0000 0240                                 case ENTR_I2C :  EtatMenu = AfficherHorloge; break;
_0x37:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x39
	LDI  R30,LOW(5)
	RJMP _0xC7
; 0000 0241                                 default : EtatMenu = Afficher;
_0x39:
	LDI  R30,LOW(1)
_0xC7:
	__PUTB1SX 105
; 0000 0242                             }
; 0000 0243 
; 0000 0244                         EtatMenu_1 = Afficher;
	LDI  R30,LOW(1)
	__PUTB1SX 104
; 0000 0245         break;
	RJMP _0x20
; 0000 0246 //---------------------------------------------------------------------------------------------------------------
; 0000 0247 // Menu [3] : Tests
; 0000 0248 //          [31] -> Chauffage
; 0000 0249 //          [32] -> Ventilation
; 0000 024A //          [33] -> Trappes
; 0000 024B //---------------------------------------------------------------------------------------------------------------
; 0000 024C         case Tester: if (EtatMenu_1 != EtatMenu)
_0x31:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x3A
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BREQ _0x3B
; 0000 024D                             {
; 0000 024E                                 sprintf(display_buffer_ligne0,TexteMenusTester);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenusTester*2)
	LDI  R31,HIGH(_TexteMenusTester*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 024F         	                    sprintf(display_buffer_ligne1,TexteMenuAcquiter);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuAcquiter*2)
	LDI  R31,HIGH(_TexteMenuAcquiter*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0250         	                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0251                                 AfficheCaracterePersoSurLCD(FlecheH,15,0);// FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0252                                 AfficheCaracterePersoSurLCD(FlecheB,15,1);// FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0253                             }
; 0000 0254 
; 0000 0255                         switch (BP)
_0x3B:
	__GETB1SX 106
	LDI  R31,0
; 0000 0256                             {
; 0000 0257                                 case FlecheB_I2C: EtatMenu = Reguler; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x3F
	LDI  R30,LOW(4)
	RJMP _0xC8
; 0000 0258                                 case FlecheH_I2C: EtatMenu = Afficher; break;
_0x3F:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x40
	LDI  R30,LOW(1)
	RJMP _0xC8
; 0000 0259                                 case ENTR_I2C :  EtatMenu = TesterChauffage; break;
_0x40:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x42
	LDI  R30,LOW(7)
	RJMP _0xC8
; 0000 025A                                 default : EtatMenu = Tester;
_0x42:
	LDI  R30,LOW(2)
_0xC8:
	__PUTB1SX 105
; 0000 025B                             }
; 0000 025C 
; 0000 025D                         EtatMenu_1 = Tester;
	LDI  R30,LOW(2)
	__PUTB1SX 104
; 0000 025E         break;
	RJMP _0x20
; 0000 025F //---------------------------------------------------------------------------------------------------------------
; 0000 0260 // Menu [4] : Rgulation
; 0000 0261 //---------------------------------------------------------------------------------------------------------------
; 0000 0262         case Reguler: if (EtatMenu_1 != EtatMenu)
_0x3A:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x43
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BREQ _0x44
; 0000 0263                             {
; 0000 0264                                 sprintf(display_buffer_ligne0,TexteMenuRegulerTOR);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuRegulerTOR*2)
	LDI  R31,HIGH(_TexteMenuRegulerTOR*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0265         	                    sprintf(display_buffer_ligne1,TexteMenuAcquiter);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuAcquiter*2)
	LDI  R31,HIGH(_TexteMenuAcquiter*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0266         	                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0267                                 AfficheCaracterePersoSurLCD(FlecheH,15,0);// FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0268                                 AfficheCaracterePersoSurLCD(FlecheB,15,1);// FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0269                             }
; 0000 026A 
; 0000 026B                         switch (BP)
_0x44:
	__GETB1SX 106
	LDI  R31,0
; 0000 026C                             {
; 0000 026D                                 case FlecheB_I2C: EtatMenu = ReglerHTR; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x48
	LDI  R30,LOW(0)
	RJMP _0xC9
; 0000 026E                                 case FlecheH_I2C: EtatMenu = Tester; break;
_0x48:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x49
	LDI  R30,LOW(2)
	RJMP _0xC9
; 0000 026F                                 case ENTR_I2C :  EtatMenu = RegulationTOR; break;
_0x49:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x4B
	LDI  R30,LOW(14)
	RJMP _0xC9
; 0000 0270                                 default : EtatMenu = Reguler;
_0x4B:
	LDI  R30,LOW(4)
_0xC9:
	__PUTB1SX 105
; 0000 0271                             }
; 0000 0272 
; 0000 0273                         EtatMenu_1 = Reguler;
	LDI  R30,LOW(4)
	__PUTB1SX 104
; 0000 0274         break;
	RJMP _0x20
; 0000 0275 //---------------------------------------------------------------------------------------------------------------
; 0000 0276 // Fin des menus
; 0000 0277 //---------------------------------------------------------------------------------------------------------------
; 0000 0278 // Dbut des sous-menus
; 0000 0279 //---------------------------------------------------------------------------------------------------------------
; 0000 027A // Sous menu [21] : Affichage de la date et de l'heure
; 0000 027B //---------------------------------------------------------------------------------------------------------------
; 0000 027C          case AfficherHorloge: if ((EtatMenu_1 != EtatMenu) || (Secondes_n_1H != Secondes_n))
_0x43:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x4C
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BRNE _0x4E
	__GETB1SX 110
	__GETB2SX 107
	CP   R30,R26
	BRNE _0x4E
	RJMP _0x4D
_0x4E:
; 0000 027D         		                {
; 0000 027E         		                    rtc_get_date(AdresseHTR,&Jour,&Mois,&Annee);
	LDI  R30,LOW(0)
	ST   -Y,R30
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R19
	IN   R30,SPL
	IN   R31,SPH
	ST   -Y,R31
	ST   -Y,R30
	PUSH R18
	IN   R30,SPL
	IN   R31,SPH
	SBIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	PUSH R21
	PUSH R20
	CALL _rtc_get_date
	POP  R20
	POP  R21
	POP  R18
	POP  R19
; 0000 027F         		                    sprintf(display_buffer_ligne0,"[21] %-u/%-u/%-i", Jour, Mois, Annee);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,126
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOV  R30,R18
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	MOVW R30,R20
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0000 0280         		                    sprintf(display_buffer_ligne1,"  %-uh/%-umn/%-us", Heures, Minutes, Secondes_n);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,143
	ST   -Y,R31
	ST   -Y,R30
	__GETB1SX 116
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETB1SX 119
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETB1SX 122
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
; 0000 0281         		                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0282         	                        Secondes_n_1H = Secondes_n;
	__GETB1SX 110
	__PUTB1SX 107
; 0000 0283                                     AfficheCaracterePersoSurLCD(FlecheH,15,0);// FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0284                                     AfficheCaracterePersoSurLCD(FlecheB,15,1);// FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 0285         	                    }
; 0000 0286 
; 0000 0287                                 switch (BP)
_0x4D:
	__GETB1SX 106
	LDI  R31,0
; 0000 0288                                 {
; 0000 0289                                     case FlecheB_I2C: EtatMenu = AfficherMesures; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x53
	LDI  R30,LOW(6)
	RJMP _0xCA
; 0000 028A                                     case FlecheH_I2C: EtatMenu = AfficherMesures; break;
_0x53:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x54
	LDI  R30,LOW(6)
	RJMP _0xCA
; 0000 028B                                     case ECHAP_I2C :  EtatMenu = Afficher; break;
_0x54:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x56
	LDI  R30,LOW(1)
	RJMP _0xCA
; 0000 028C                                     default : EtatMenu = AfficherHorloge;
_0x56:
	LDI  R30,LOW(5)
_0xCA:
	__PUTB1SX 105
; 0000 028D                                 }
; 0000 028E 
; 0000 028F         		                EtatMenu_1 = AfficherHorloge;
	LDI  R30,LOW(5)
	__PUTB1SX 104
; 0000 0290         break;
	RJMP _0x20
; 0000 0291 //---------------------------------------------------------------------------------------------------------------
; 0000 0292 // Sous menu [22] : Affichage des mesures sur le LCD
; 0000 0293 //---------------------------------------------------------------------------------------------------------------
; 0000 0294          case AfficherMesures : if ((EtatMenu_1 != EtatMenu) || (TemperatureExterieure_n_1 != TemperatureExterieure_n)
_0x4C:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x57
; 0000 0295                                                      || (RH_n_1 != RH_n) || (JourOuNuit_n != JourOuNuit_n_1 )
; 0000 0296                                                      || (TemperatureInterieure_n_1 != TemperatureInterieure_n))
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BREQ PC+3
	JMP _0x59
	__GETW1SX 89
	__GETW2SX 91
	CP   R30,R26
	CPC  R31,R27
	BRNE _0x59
	__GETD1SX 98
	__GETD2SX 94
	CALL __CPD12
	BRNE _0x59
	__GETB1SX 71
	__GETB2SX 70
	CP   R30,R26
	BRNE _0x59
	__GETD1SX 77
	__GETD2SX 73
	CALL __CPD12
	BRNE _0x59
	RJMP _0x58
_0x59:
; 0000 0297                                 {
; 0000 0298                                     // Mise en forme de la valeur de l'humidit pour affichage
; 0000 0299         	                        ftoa(RH_n,0,ChaineHumidite);
	__GETD1SX 98
	CALL __PUTPARD1
	LDI  R30,LOW(0)
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(70))
	SBCI R31,HIGH(-(70))
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 029A                                     sprintf(display_buffer_ligne0,"[22]   RH=%-s%-c",ChaineHumidite,0x25);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,161
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(69))
	SBCI R31,HIGH(-(69))
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0x25
	CALL __PUTPARD1
	LDI  R24,8
	CALL _sprintf
	ADIW R28,12
; 0000 029B 
; 0000 029C         	                        // Mise en forme de la valeur des tempratures extrieure et intrieure pour affichage
; 0000 029D                                     ftoa(TemperatureInterieure_n,1,ChaineTemperatureInterieure);
	__GETD1SX 77
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,60
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 029E                                     sprintf(display_buffer_ligne1,"E=%-i.%-u%-c I=%-s%-c",TemperatureExterieure_n/10,
; 0000 029F                                     abs(TemperatureExterieure_n%10),0xdf,ChaineTemperatureInterieure,0xdf);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,178
	ST   -Y,R31
	ST   -Y,R30
	__GETW2SX 93
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETW2SX 97
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21U
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0xDF
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(71))
	SBCI R31,HIGH(-(71))
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0xDF
	CALL __PUTPARD1
	LDI  R24,20
	CALL _sprintf
	ADIW R28,24
; 0000 02A0 
; 0000 02A1                                     // Affichage de l'humidit et des tempratures sur le LCD
; 0000 02A2                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 02A3 
; 0000 02A4                                     // Affichage de l'icone JourOuNuit sur le LCD
; 0000 02A5                                     if (JourOuNuit_n == 0) AfficheCaracterePersoSurLCD(Soleil,5,0); // Icne Soleil en C4,L0
	__GETB1SX 70
	CPI  R30,0
	BRNE _0x5B
	LDI  R30,LOW(2)
	RJMP _0xCB
; 0000 02A6                                             else AfficheCaracterePersoSurLCD(Lune,5,0);             // Icne Lune en C4,L0
_0x5B:
	LDI  R30,LOW(3)
_0xCB:
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02A7 
; 0000 02A8                                     // Affichage des icnes flche sur le LCD
; 0000 02A9                                     AfficheCaracterePersoSurLCD(FlecheH,15,0);// Icne FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02AA                                     AfficheCaracterePersoSurLCD(FlecheB,15,1);// Icne FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02AB 
; 0000 02AC                                     // Mise  jour des variables
; 0000 02AD                                     RH_n_1 = RH_n; TemperatureExterieure_n_1 = TemperatureExterieure_n;
	__GETD1SX 98
	__PUTD1SX 94
	__GETW1SX 89
	__PUTW1SX 91
; 0000 02AE                                     JourOuNuit_n_1 = JourOuNuit_n; TemperatureInterieure_n_1 = TemperatureInterieure_n;
	__GETB1SX 70
	__PUTB1SX 71
	__GETD1SX 77
	__PUTD1SX 73
; 0000 02AF         		                }
; 0000 02B0 
; 0000 02B1                                 switch (BP)
_0x58:
	__GETB1SX 106
	LDI  R31,0
; 0000 02B2                                 {
; 0000 02B3                                     case FlecheB_I2C: EtatMenu = AfficherHorloge; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x60
	LDI  R30,LOW(5)
	RJMP _0xCC
; 0000 02B4                                     case FlecheH_I2C: EtatMenu = AfficherHorloge; break;
_0x60:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x61
	LDI  R30,LOW(5)
	RJMP _0xCC
; 0000 02B5                                     case ECHAP_I2C :  EtatMenu = Afficher; break;
_0x61:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x63
	LDI  R30,LOW(1)
	RJMP _0xCC
; 0000 02B6                                     default : EtatMenu = AfficherMesures;
_0x63:
	LDI  R30,LOW(6)
_0xCC:
	__PUTB1SX 105
; 0000 02B7                                 }
; 0000 02B8 
; 0000 02B9         		                EtatMenu_1 = AfficherMesures  ;
	LDI  R30,LOW(6)
	__PUTB1SX 104
; 0000 02BA          break;
	RJMP _0x20
; 0000 02BB //---------------------------------------------------------------------------------------------------------------
; 0000 02BC // Sous menu [31] : Test du chauffage (PWM)
; 0000 02BD //---------------------------------------------------------------------------------------------------------------
; 0000 02BE         case TesterChauffage :	if (EtatMenu_1 != EtatMenu)
_0x57:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x64
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BREQ _0x65
; 0000 02BF                                  {
; 0000 02C0                                     sprintf(display_buffer_ligne0,TexteSousMenuChauffage);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteSousMenuChauffage*2)
	LDI  R31,HIGH(_TexteSousMenuChauffage*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02C1                                     sprintf(display_buffer_ligne1,TexteMenuAcquitQuitter);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuAcquitQuitter*2)
	LDI  R31,HIGH(_TexteMenuAcquitQuitter*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02C2                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 02C3                                     AfficheCaracterePersoSurLCD(FlecheH,15,0);// Icne FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02C4                                     AfficheCaracterePersoSurLCD(FlecheB,15,1);// Icne FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02C5                                  }
; 0000 02C6 
; 0000 02C7                                 switch(BP)
_0x65:
	__GETB1SX 106
	LDI  R31,0
; 0000 02C8         		                 {
; 0000 02C9         		                    case FlecheB_I2C : EtatMenu = TesterVentilation; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x69
	LDI  R30,LOW(8)
	RJMP _0xCD
; 0000 02CA         		                    case FlecheH_I2C : EtatMenu = TesterTrappes; break;
_0x69:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x6A
	LDI  R30,LOW(9)
	RJMP _0xCD
; 0000 02CB         		                    case ENTR_I2C:  EtatMenu = CommanderChauffageManu; break;
_0x6A:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x6B
	LDI  R30,LOW(10)
	RJMP _0xCD
; 0000 02CC                                     case ECHAP_I2C: EtatMenu = Tester; break;
_0x6B:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x6D
	LDI  R30,LOW(2)
	RJMP _0xCD
; 0000 02CD         		                    default  : EtatMenu = TesterChauffage;
_0x6D:
	LDI  R30,LOW(7)
_0xCD:
	__PUTB1SX 105
; 0000 02CE         		                 }
; 0000 02CF        			                EtatMenu_1 = TesterChauffage;
	LDI  R30,LOW(7)
	__PUTB1SX 104
; 0000 02D0         break;
	RJMP _0x20
; 0000 02D1 //---------------------------------------------------------------------------------------------------------------
; 0000 02D2 // Sous menu [32] : Test de la ventilation (PWM)
; 0000 02D3 //---------------------------------------------------------------------------------------------------------------
; 0000 02D4         case TesterVentilation :	if (EtatMenu_1 != EtatMenu)
_0x64:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x6E
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BREQ _0x6F
; 0000 02D5                                 {
; 0000 02D6                                     sprintf(display_buffer_ligne0,TexteSousMenuVentilation);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteSousMenuVentilation*2)
	LDI  R31,HIGH(_TexteSousMenuVentilation*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02D7                                     sprintf(display_buffer_ligne1,TexteMenuAcquitQuitter);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuAcquitQuitter*2)
	LDI  R31,HIGH(_TexteMenuAcquitQuitter*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02D8                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 02D9                                     AfficheCaracterePersoSurLCD(FlecheH,15,0);// Icne FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02DA                                     AfficheCaracterePersoSurLCD(FlecheB,15,1);// Icne FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02DB                                 }
; 0000 02DC 
; 0000 02DD                             switch(BP)
_0x6F:
	__GETB1SX 106
	LDI  R31,0
; 0000 02DE         		                {
; 0000 02DF         		                    case FlecheB_I2C : EtatMenu = TesterTrappes; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x73
	LDI  R30,LOW(9)
	RJMP _0xCE
; 0000 02E0         		                    case FlecheH_I2C : EtatMenu = TesterChauffage; break;
_0x73:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x74
	LDI  R30,LOW(7)
	RJMP _0xCE
; 0000 02E1         		                    case ENTR_I2C:  EtatMenu = CommanderVentilationManu; break;
_0x74:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x75
	LDI  R30,LOW(11)
	RJMP _0xCE
; 0000 02E2                                     case ECHAP_I2C: EtatMenu = Tester; break;
_0x75:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x77
	LDI  R30,LOW(2)
	RJMP _0xCE
; 0000 02E3         		                    default  : EtatMenu = TesterVentilation;
_0x77:
	LDI  R30,LOW(8)
_0xCE:
	__PUTB1SX 105
; 0000 02E4         		                }
; 0000 02E5        			            EtatMenu_1 = TesterVentilation;
	LDI  R30,LOW(8)
	__PUTB1SX 104
; 0000 02E6         break;
	RJMP _0x20
; 0000 02E7 //---------------------------------------------------------------------------------------------------------------
; 0000 02E8 // Sous menu [33] : Test de la commande des trappes (PWM)
; 0000 02E9 //---------------------------------------------------------------------------------------------------------------
; 0000 02EA         case TesterTrappes :if (EtatMenu_1 != EtatMenu)
_0x6E:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x78
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BREQ _0x79
; 0000 02EB                                 {
; 0000 02EC                                     sprintf(display_buffer_ligne0,TexteSousMenuTrappes);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteSousMenuTrappes*2)
	LDI  R31,HIGH(_TexteSousMenuTrappes*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02ED                                     sprintf(display_buffer_ligne1,TexteMenuAcquitQuitter);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuAcquitQuitter*2)
	LDI  R31,HIGH(_TexteMenuAcquitQuitter*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 02EE                                     Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 02EF                                     AfficheCaracterePersoSurLCD(FlecheH,15,0);// Icne FlecheH en C15,L0
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02F0                                     AfficheCaracterePersoSurLCD(FlecheB,15,1);// Icne FlecheB en C15,L1
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDI  R30,LOW(15)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _AfficheCaracterePersoSurLCD
; 0000 02F1                                 }
; 0000 02F2 
; 0000 02F3                             switch(BP)
_0x79:
	__GETB1SX 106
	LDI  R31,0
; 0000 02F4         		                {
; 0000 02F5         		                    case FlecheB_I2C : EtatMenu = TesterChauffage; break;
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x7D
	LDI  R30,LOW(7)
	RJMP _0xCF
; 0000 02F6         		                    case FlecheH_I2C : EtatMenu = TesterVentilation; break;
_0x7D:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x7E
	LDI  R30,LOW(8)
	RJMP _0xCF
; 0000 02F7         		                    case ENTR_I2C:  EtatMenu = CommanderTrappesManu; break;
_0x7E:
	CPI  R30,LOW(0x40)
	LDI  R26,HIGH(0x40)
	CPC  R31,R26
	BRNE _0x7F
	LDI  R30,LOW(12)
	RJMP _0xCF
; 0000 02F8                                     case ECHAP_I2C: EtatMenu = Tester; break;
_0x7F:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x81
	LDI  R30,LOW(2)
	RJMP _0xCF
; 0000 02F9         		                    default  : EtatMenu = TesterTrappes;
_0x81:
	LDI  R30,LOW(9)
_0xCF:
	__PUTB1SX 105
; 0000 02FA         		                }
; 0000 02FB        			            EtatMenu_1 = TesterTrappes;
	LDI  R30,LOW(9)
	__PUTB1SX 104
; 0000 02FC         break;
	RJMP _0x20
; 0000 02FD  //---------------------------------------------------------------------------------------------------------------
; 0000 02FE // Sous menu 41: Rgulation TOR
; 0000 02FF //---------------------------------------------------------------------------------------------------------------
; 0000 0300         case RegulationTOR :  if ((EtatMenu_1 != EtatMenu) || (TemperatureInterieure_n_1 != TemperatureInterieure_n))
_0x78:
	CPI  R30,LOW(0xE)
	LDI  R26,HIGH(0xE)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x82
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BRNE _0x84
	__GETD1SX 77
	__GETD2SX 73
	CALL __CPD12
	BRNE _0x84
	RJMP _0x83
_0x84:
; 0000 0301        	                            {
; 0000 0302                                         // Prparation de l'affichage des seuils de temprature et de la temprature
; 0000 0303                                         // intrieure sur le LCD
; 0000 0304                                         ftoa(TemperatureInterieure_n,1, ChaineTemperatureInterieure);
	__GETD1SX 77
	CALL __PUTPARD1
	LDI  R30,LOW(1)
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,60
	ST   -Y,R31
	ST   -Y,R30
	CALL _ftoa
; 0000 0305                                         sprintf(display_buffer_ligne0,"Sn=%-s%-c T=%-s%-c",ChaineSeuilTempIntSimuleMin,0xdf,
; 0000 0306        		   	                        ChaineTemperatureInterieure,0xdf);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,200
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,54
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0xDF
	CALL __PUTPARD1
	MOVW R30,R28
	SUBI R30,LOW(-(67))
	SBCI R31,HIGH(-(67))
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0xDF
	CALL __PUTPARD1
	LDI  R24,16
	CALL _sprintf
	ADIW R28,20
; 0000 0307        		                            sprintf(display_buffer_ligne1,"Sx=%-s%-c P=%-u%-c",ChaineSeuilTempIntSimuleMax,0xdf,
; 0000 0308        		   	                        CommandeChauffage,'%');
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,219
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,49
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0xDF
	CALL __PUTPARD1
	LDD  R30,Y+13
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0x25
	CALL __PUTPARD1
	LDI  R24,16
	CALL _sprintf
	ADIW R28,20
; 0000 0309                                         // Affichage
; 0000 030A        		                            Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 030B        		                            TemperatureInterieure_n_1 = TemperatureInterieure_n;
	__GETD1SX 77
	__PUTD1SX 73
; 0000 030C 			                        }
; 0000 030D 
; 0000 030E                                     // Commande du chauffage (hystrsis)
; 0000 030F                                     if (TemperatureInterieure_n >= SeuilTempIntSimuleMax)
_0x83:
	__GETD1SX 81
	__GETD2SX 77
	CALL __CMPF12
	BRLO _0x86
; 0000 0310                                      {
; 0000 0311                                         PWMChauffage=alphaChauffage[0]; // Cde chauffage = 0%
	LDD  R30,Y+7
	LDD  R31,Y+7+1
	OUT  0x28+1,R31
	OUT  0x28,R30
; 0000 0312                                         CommandeChauffage = 0;
	LDI  R30,LOW(0)
	RJMP _0xD0
; 0000 0313                                      }
; 0000 0314                                     else if  (TemperatureInterieure_n <= SeuilTempIntSimuleMin)
_0x86:
	__GETD1SX 85
	__GETD2SX 77
	CALL __CMPF12
	BREQ PC+4
	BRCS PC+3
	JMP  _0x88
; 0000 0315                                       {
; 0000 0316                                         PWMChauffage=alphaChauffage[10];  // Cde chauffage = 100%
	LDD  R30,Y+27
	LDD  R31,Y+27+1
	OUT  0x28+1,R31
	OUT  0x28,R30
; 0000 0317                                         CommandeChauffage = 100;
	LDI  R30,LOW(100)
_0xD0:
	STD  Y+1,R30
; 0000 0318                                       }
; 0000 0319 
; 0000 031A                                     if (BP==ECHAP_I2C) {EtatMenu = Reguler; CommandeChauffage = 0; }
_0x88:
	__GETB2SX 106
	CPI  R26,LOW(0x80)
	BRNE _0x89
	LDI  R30,LOW(4)
	__PUTB1SX 105
	LDI  R30,LOW(0)
	STD  Y+1,R30
; 0000 031B 
; 0000 031C          		                    EtatMenu_1 = RegulationTOR;
_0x89:
	LDI  R30,LOW(14)
	__PUTB1SX 104
; 0000 031D         break;
	RJMP _0x20
; 0000 031E //---------------------------------------------------------------------------------------------------------------
; 0000 031F //Fin des sous-menus
; 0000 0320 //---------------------------------------------------------------------------------------------------------------
; 0000 0321 // Commande manuelle du chauffage
; 0000 0322 //---------------------------------------------------------------------------------------------------------------
; 0000 0323         case CommanderChauffageManu :  if ((EtatMenu_1 != EtatMenu)|| (rcycl_1 != rcycl))
_0x82:
	CPI  R30,LOW(0xA)
	LDI  R26,HIGH(0xA)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x8A
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BRNE _0x8C
	LDD  R30,Y+30
	LDD  R26,Y+29
	CP   R30,R26
	BREQ _0x8B
_0x8C:
; 0000 0324        			                        {
; 0000 0325        		   	                            sprintf(display_buffer_ligne0,"Rap. cycl = %-u%%",rcycl);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,238
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+34
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 0326        		                                sprintf(display_buffer_ligne1,TexteMenuPlusMoinsEsc);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuPlusMoinsEsc*2)
	LDI  R31,HIGH(_TexteMenuPlusMoinsEsc*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0327        		                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0328        		                                rcycl_1 = rcycl;
	LDD  R30,Y+30
	STD  Y+29,R30
; 0000 0329 			                            }
; 0000 032A 		                               switch(BP)
_0x8B:
	__GETB1SX 106
	LDI  R31,0
; 0000 032B 			                            {
; 0000 032C 				                            case PLUS_I2C: if (rcycl < 90) rcycl = rcycl+10; else rcycl = 100; break;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x91
	LDD  R26,Y+30
	CPI  R26,LOW(0x5A)
	BRSH _0x92
	LDD  R30,Y+30
	SUBI R30,-LOW(10)
	RJMP _0xD1
_0x92:
	LDI  R30,LOW(100)
_0xD1:
	STD  Y+30,R30
	RJMP _0x90
; 0000 032D 				                            case MOINS_I2C: if (rcycl > 10) rcycl = rcycl-10; else rcycl = 0; break;
_0x91:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x94
	LDD  R26,Y+30
	CPI  R26,LOW(0xB)
	BRLO _0x95
	LDD  R30,Y+30
	LDI  R31,0
	SBIW R30,10
	RJMP _0xD2
_0x95:
	LDI  R30,LOW(0)
_0xD2:
	STD  Y+30,R30
	RJMP _0x90
; 0000 032E 				                            case ECHAP_I2C : rcycl = 0; EtatMenu = TesterChauffage; break;
_0x94:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x98
	LDI  R30,LOW(0)
	STD  Y+30,R30
	LDI  R30,LOW(7)
	RJMP _0xD3
; 0000 032F 				                            default: EtatMenu = CommanderChauffageManu;
_0x98:
	LDI  R30,LOW(10)
_0xD3:
	__PUTB1SX 105
; 0000 0330                                         }
_0x90:
; 0000 0331 
; 0000 0332                                         // Visualisation de l'tat de la commande sur la Led D7
; 0000 0333 
; 0000 0334 			                            OCR1B=alphaChauffage[rcycl/10];
	LDD  R26,Y+30
	LDI  R27,0
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	MOVW R26,R28
	ADIW R26,7
	LSL  R30
	ROL  R31
	ADD  R26,R30
	ADC  R27,R31
	CALL __GETW1P
	OUT  0x28+1,R31
	OUT  0x28,R30
; 0000 0335          		                        EtatMenu_1 = CommanderChauffageManu ;
	LDI  R30,LOW(10)
	__PUTB1SX 104
; 0000 0336         break;
	RJMP _0x20
; 0000 0337 //---------------------------------------------------------------------------------------------------------------
; 0000 0338 // Commande manuelle de la ventilation
; 0000 0339 //---------------------------------------------------------------------------------------------------------------
; 0000 033A         case CommanderVentilationManu :  if ((EtatMenu_1 != EtatMenu)|| (TORVentilation_1 != TORVentilation))
_0x8A:
	CPI  R30,LOW(0xB)
	LDI  R26,HIGH(0xB)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x99
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BRNE _0x9B
	LDI  R30,0
	SBIC 0x12,5
	LDI  R30,1
	LDD  R26,Y+6
	LDI  R27,0
	LDI  R31,0
	SBRC R30,7
	SER  R31
	CP   R30,R26
	CPC  R31,R27
	BREQ _0x9A
_0x9B:
; 0000 033B        			                            {
; 0000 033C        		   	                                sprintf(display_buffer_ligne0,"Cde Ventila. = %-u",TORVentilation);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,256
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,0
	SBIC 0x12,5
	LDI  R30,1
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 033D        		                                    sprintf(display_buffer_ligne1,TexteMenuPlusMoinsEsc);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuPlusMoinsEsc*2)
	LDI  R31,HIGH(_TexteMenuPlusMoinsEsc*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 033E        		                                    Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 033F        		                                    TORVentilation_1 = TORVentilation;
	LDI  R30,0
	SBIC 0x12,5
	LDI  R30,1
	STD  Y+6,R30
; 0000 0340 			                                }
; 0000 0341 
; 0000 0342 		                                 switch(BP)
_0x9A:
	__GETB1SX 106
	LDI  R31,0
; 0000 0343 			                                {
; 0000 0344 				                                case PLUS_I2C: TORVentilation = 1; break;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xA0
	SBI  0x12,5
	RJMP _0x9F
; 0000 0345 				                                case MOINS_I2C: TORVentilation = 0; break;
_0xA0:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xA3
	CBI  0x12,5
	RJMP _0x9F
; 0000 0346 				                                case ECHAP_I2C : TORVentilation = 0;
_0xA3:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0xA9
	CBI  0x12,5
; 0000 0347                                                                  EtatMenu = TesterVentilation;
	LDI  R30,LOW(8)
	RJMP _0xD4
; 0000 0348                                                 break;
; 0000 0349 				                                default: EtatMenu = CommanderVentilationManu;
_0xA9:
	LDI  R30,LOW(11)
_0xD4:
	__PUTB1SX 105
; 0000 034A                                             }
_0x9F:
; 0000 034B 
; 0000 034C          		                         EtatMenu_1 = CommanderVentilationManu;
	LDI  R30,LOW(11)
	__PUTB1SX 104
; 0000 034D         break;
	RJMP _0x20
; 0000 034E //---------------------------------------------------------------------------------------------------------------
; 0000 034F // Commande manuelle des trappes
; 0000 0350 //---------------------------------------------------------------------------------------------------------------
; 0000 0351         case CommanderTrappesManu : do
_0x99:
	CPI  R30,LOW(0xC)
	LDI  R26,HIGH(0xC)
	CPC  R31,R26
	BREQ PC+3
	JMP _0xBC
_0xAC:
; 0000 0352                                     {
; 0000 0353                                       if ((EtatMenu_1 != EtatMenu)||(t1Servo_1 != t1Servo))
	__GETB1SX 105
	__GETB2SX 104
	CP   R30,R26
	BRNE _0xAF
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CP   R30,R26
	CPC  R31,R27
	BREQ _0xAE
_0xAF:
; 0000 0354        			                        {
; 0000 0355        		   	                            sprintf(display_buffer_ligne0,"Servo: t1=%-uus",100*(5+t1Servo));
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x0,275
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	ADIW R30,5
	LDI  R26,LOW(100)
	LDI  R27,HIGH(100)
	CALL __MULW12U
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,4
	CALL _sprintf
	ADIW R28,8
; 0000 0356        		                                sprintf(display_buffer_ligne1,TexteMenuPlusMoinsEsc);
	MOVW R30,R28
	SUBI R30,LOW(-(113))
	SBCI R31,HIGH(-(113))
	ST   -Y,R31
	ST   -Y,R30
	LDI  R30,LOW(_TexteMenuPlusMoinsEsc*2)
	LDI  R31,HIGH(_TexteMenuPlusMoinsEsc*2)
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
; 0000 0357        		                                Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	MOVW R30,R28
	SUBI R30,LOW(-(130))
	SBCI R31,HIGH(-(130))
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	SUBI R30,LOW(-(115))
	SBCI R31,HIGH(-(115))
	ST   -Y,R31
	ST   -Y,R30
	CALL _Affiche_LCD
; 0000 0358        		                                t1Servo_1 = t1Servo;
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	STD  Y+2,R30
	STD  Y+2+1,R31
; 0000 0359 			                            }
; 0000 035A 
; 0000 035B 		                              BP = Lire_BP_I2C_Soft();
_0xAE:
	CALL _Lire_BP_I2C_Soft
	__PUTB1SX 106
; 0000 035C 
; 0000 035D                                        switch(BP)
	LDI  R31,0
; 0000 035E 			                            {
; 0000 035F 				                            case PLUS_I2C:if (t1Servo < 20) t1Servo = t1Servo+1;
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xB4
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,20
	BRSH _0xB5
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ADIW R30,1
	RJMP _0xD5
; 0000 0360                                                             else t1Servo = 20;
_0xB5:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
_0xD5:
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 0361                                             break;
	RJMP _0xB3
; 0000 0362 				                            case MOINS_I2C: if (t1Servo > 1) t1Servo = t1Servo-1;
_0xB4:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0xB7
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,2
	BRLO _0xB8
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	SBIW R30,1
	STD  Y+4,R30
	STD  Y+4+1,R31
; 0000 0363                                                         else t1Servo = 0;
	RJMP _0xB9
_0xB8:
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
; 0000 0364                                             break;
_0xB9:
	RJMP _0xB3
; 0000 0365 				                            case ECHAP_I2C : t1Servo = 0; EtatMenu = TesterTrappes; break;
_0xB7:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0xBB
	LDI  R30,LOW(0)
	STD  Y+4,R30
	STD  Y+4+1,R30
	LDI  R30,LOW(9)
	RJMP _0xD6
; 0000 0366 				                            default: EtatMenu = CommanderTrappesManu;
_0xBB:
	LDI  R30,LOW(12)
_0xD6:
	__PUTB1SX 105
; 0000 0367                                         }
_0xB3:
; 0000 0368 
; 0000 0369                                         ReglagePWMServo(t1Servo);
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _ReglagePWMServo
; 0000 036A                                       }
; 0000 036B                                     while(EtatMenu != TesterTrappes);
	__GETB2SX 105
	CPI  R26,LOW(0x9)
	BREQ _0xAD
	RJMP _0xAC
_0xAD:
; 0000 036C 
; 0000 036D          		                    EtatMenu_1 = CommanderTrappesManu;
	LDI  R30,LOW(12)
	__PUTB1SX 104
; 0000 036E         break;
	RJMP _0x20
; 0000 036F //---------------------------------------------------------------------------------------------------------------
; 0000 0370         default:     EtatMenu = Afficher;
_0xBC:
	LDI  R30,LOW(1)
	__PUTB1SX 105
; 0000 0371     }
_0x20:
; 0000 0372 //---------------------------------------------------------------------------------------------------------------
; 0000 0373 // Dbut Traiter / Communiquer
; 0000 0374 //---------------------------------------------------------------------------------------------------------------
; 0000 0375  } // fin du while(1)
	JMP  _0xA
; 0000 0376 // ==============================================================================================================
; 0000 0377 } // fin
_0xBD:
	RJMP _0xBD
;// ==============================================================================================================
;
;// ==============================================================================================================
;// Sous-programmes
;//---------------------------------------------------------------------------------------------------------------
;void AfficheCaracterePersoSurLCD(unsigned char numero, unsigned char posColonne, unsigned char posLigne)
; 0000 037E {
_AfficheCaracterePersoSurLCD:
; 0000 037F     lcd_gotoxy(posColonne,posLigne);	// Affichage Jour
;	numero -> Y+2
;	posColonne -> Y+1
;	posLigne -> Y+0
	LDD  R30,Y+1
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _lcd_gotoxy
; 0000 0380     lcd_putchar(numero);
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _lcd_putchar
; 0000 0381 }
	RJMP _0x216000E
;//---------------------------------------------------------------------------------------------------------------
;unsigned char ReglagePWMServo(unsigned int Reglaget1Servo)
; 0000 0384     {
_ReglagePWMServo:
; 0000 0385         unsigned char i;
; 0000 0386         PWMTrappes = 1;
	ST   -Y,R17
;	Reglaget1Servo -> Y+1
;	i -> R17
	SBI  0x12,7
; 0000 0387         for (i=0;i<5+Reglaget1Servo;i++)
	LDI  R17,LOW(0)
_0xC1:
	LDD  R30,Y+1
	LDD  R31,Y+1+1
	ADIW R30,5
	MOV  R26,R17
	LDI  R27,0
	CP   R26,R30
	CPC  R27,R31
	BRSH _0xC2
; 0000 0388         {
; 0000 0389             delay_us(100);
	__DELAY_USW 200
; 0000 038A         }
	SUBI R17,-1
	RJMP _0xC1
_0xC2:
; 0000 038B         PWMTrappes = 0;
	CBI  0x12,7
; 0000 038C         delay_ms(10);
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
; 0000 038D         return 0;
	LDI  R30,LOW(0)
	RJMP _0x216000D
; 0000 038E     }
;// ==============================================================================================================
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif

	.CSEG
_putchar:
putchar0:
     sbis usr,udre
     rjmp putchar0
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
_puts:
	ST   -Y,R17
_0x2000003:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x2000005
	ST   -Y,R17
	RCALL _putchar
	RJMP _0x2000003
_0x2000005:
	LDI  R30,LOW(10)
	ST   -Y,R30
	RCALL _putchar
_0x216000D:
	LDD  R17,Y+0
_0x216000E:
	ADIW R28,3
	RET
_put_buff_G100:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x2000010
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,4
	CALL __GETW1P
	MOVW R16,R30
	SBIW R30,0
	BREQ _0x2000012
	__CPWRN 16,17,2
	BRLO _0x2000013
	MOVW R30,R16
	SBIW R30,1
	MOVW R16,R30
	__PUTW1SNS 2,4
_0x2000012:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ADIW R26,2
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
	SBIW R30,1
	LDD  R26,Y+4
	STD  Z+0,R26
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __GETW1P
	TST  R31
	BRMI _0x2000014
	LD   R30,X+
	LD   R31,X+
	ADIW R30,1
	ST   -X,R31
	ST   -X,R30
_0x2000014:
_0x2000013:
	RJMP _0x2000015
_0x2000010:
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	ST   X+,R30
	ST   X,R31
_0x2000015:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,5
	RET
__print_G100:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R17,0
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	ST   X+,R30
	ST   X,R31
_0x2000016:
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	ADIW R30,1
	STD  Y+18,R30
	STD  Y+18+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R18,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x2000018
	MOV  R30,R17
	CPI  R30,0
	BRNE _0x200001C
	CPI  R18,37
	BRNE _0x200001D
	LDI  R17,LOW(1)
	RJMP _0x200001E
_0x200001D:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
_0x200001E:
	RJMP _0x200001B
_0x200001C:
	CPI  R30,LOW(0x1)
	BRNE _0x200001F
	CPI  R18,37
	BRNE _0x2000020
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x20000C9
_0x2000020:
	LDI  R17,LOW(2)
	LDI  R20,LOW(0)
	LDI  R16,LOW(0)
	CPI  R18,45
	BRNE _0x2000021
	LDI  R16,LOW(1)
	RJMP _0x200001B
_0x2000021:
	CPI  R18,43
	BRNE _0x2000022
	LDI  R20,LOW(43)
	RJMP _0x200001B
_0x2000022:
	CPI  R18,32
	BRNE _0x2000023
	LDI  R20,LOW(32)
	RJMP _0x200001B
_0x2000023:
	RJMP _0x2000024
_0x200001F:
	CPI  R30,LOW(0x2)
	BRNE _0x2000025
_0x2000024:
	LDI  R21,LOW(0)
	LDI  R17,LOW(3)
	CPI  R18,48
	BRNE _0x2000026
	ORI  R16,LOW(128)
	RJMP _0x200001B
_0x2000026:
	RJMP _0x2000027
_0x2000025:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0x200001B
_0x2000027:
	CPI  R18,48
	BRLO _0x200002A
	CPI  R18,58
	BRLO _0x200002B
_0x200002A:
	RJMP _0x2000029
_0x200002B:
	LDI  R26,LOW(10)
	MUL  R21,R26
	MOV  R21,R0
	MOV  R30,R18
	SUBI R30,LOW(48)
	ADD  R21,R30
	RJMP _0x200001B
_0x2000029:
	MOV  R30,R18
	CPI  R30,LOW(0x63)
	BRNE _0x200002F
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Z+4
	ST   -Y,R26
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x2000030
_0x200002F:
	CPI  R30,LOW(0x73)
	BRNE _0x2000032
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlen
	MOV  R17,R30
	RJMP _0x2000033
_0x2000032:
	CPI  R30,LOW(0x70)
	BRNE _0x2000035
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	CALL _strlenf
	MOV  R17,R30
	ORI  R16,LOW(8)
_0x2000033:
	ORI  R16,LOW(2)
	ANDI R16,LOW(127)
	LDI  R19,LOW(0)
	RJMP _0x2000036
_0x2000035:
	CPI  R30,LOW(0x64)
	BREQ _0x2000039
	CPI  R30,LOW(0x69)
	BRNE _0x200003A
_0x2000039:
	ORI  R16,LOW(4)
	RJMP _0x200003B
_0x200003A:
	CPI  R30,LOW(0x75)
	BRNE _0x200003C
_0x200003B:
	LDI  R30,LOW(_tbl10_G100*2)
	LDI  R31,HIGH(_tbl10_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(5)
	RJMP _0x200003D
_0x200003C:
	CPI  R30,LOW(0x58)
	BRNE _0x200003F
	ORI  R16,LOW(8)
	RJMP _0x2000040
_0x200003F:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0x2000071
_0x2000040:
	LDI  R30,LOW(_tbl16_G100*2)
	LDI  R31,HIGH(_tbl16_G100*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R17,LOW(4)
_0x200003D:
	SBRS R16,2
	RJMP _0x2000042
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+11
	TST  R26
	BRPL _0x2000043
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R20,LOW(45)
_0x2000043:
	CPI  R20,0
	BREQ _0x2000044
	SUBI R17,-LOW(1)
	RJMP _0x2000045
_0x2000044:
	ANDI R16,LOW(251)
_0x2000045:
	RJMP _0x2000046
_0x2000042:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	SBIW R30,4
	STD  Y+16,R30
	STD  Y+16+1,R31
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	ADIW R26,4
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0x2000046:
_0x2000036:
	SBRC R16,0
	RJMP _0x2000047
_0x2000048:
	CP   R17,R21
	BRSH _0x200004A
	SBRS R16,7
	RJMP _0x200004B
	SBRS R16,2
	RJMP _0x200004C
	ANDI R16,LOW(251)
	MOV  R18,R20
	SUBI R17,LOW(1)
	RJMP _0x200004D
_0x200004C:
	LDI  R18,LOW(48)
_0x200004D:
	RJMP _0x200004E
_0x200004B:
	LDI  R18,LOW(32)
_0x200004E:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	SUBI R21,LOW(1)
	RJMP _0x2000048
_0x200004A:
_0x2000047:
	MOV  R19,R17
	SBRS R16,1
	RJMP _0x200004F
_0x2000050:
	CPI  R19,0
	BREQ _0x2000052
	SBRS R16,3
	RJMP _0x2000053
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	LPM  R18,Z+
	STD  Y+6,R30
	STD  Y+6+1,R31
	RJMP _0x2000054
_0x2000053:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R18,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x2000054:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x2000055
	SUBI R21,LOW(1)
_0x2000055:
	SUBI R19,LOW(1)
	RJMP _0x2000050
_0x2000052:
	RJMP _0x2000056
_0x200004F:
_0x2000058:
	LDI  R18,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
_0x200005A:
	LDD  R30,Y+8
	LDD  R31,Y+8+1
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	CP   R26,R30
	CPC  R27,R31
	BRLO _0x200005C
	SUBI R18,-LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	SUB  R30,R26
	SBC  R31,R27
	STD  Y+10,R30
	STD  Y+10+1,R31
	RJMP _0x200005A
_0x200005C:
	CPI  R18,58
	BRLO _0x200005D
	SBRS R16,3
	RJMP _0x200005E
	SUBI R18,-LOW(7)
	RJMP _0x200005F
_0x200005E:
	SUBI R18,-LOW(39)
_0x200005F:
_0x200005D:
	SBRC R16,4
	RJMP _0x2000061
	CPI  R18,49
	BRSH _0x2000063
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,1
	BRNE _0x2000062
_0x2000063:
	RJMP _0x20000CA
_0x2000062:
	CP   R21,R19
	BRLO _0x2000067
	SBRS R16,0
	RJMP _0x2000068
_0x2000067:
	RJMP _0x2000066
_0x2000068:
	LDI  R18,LOW(32)
	SBRS R16,7
	RJMP _0x2000069
	LDI  R18,LOW(48)
_0x20000CA:
	ORI  R16,LOW(16)
	SBRS R16,2
	RJMP _0x200006A
	ANDI R16,LOW(251)
	ST   -Y,R20
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x200006B
	SUBI R21,LOW(1)
_0x200006B:
_0x200006A:
_0x2000069:
_0x2000061:
	ST   -Y,R18
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	CPI  R21,0
	BREQ _0x200006C
	SUBI R21,LOW(1)
_0x200006C:
_0x2000066:
	SUBI R19,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	SBIW R26,2
	BRLO _0x2000059
	RJMP _0x2000058
_0x2000059:
_0x2000056:
	SBRS R16,0
	RJMP _0x200006D
_0x200006E:
	CPI  R21,0
	BREQ _0x2000070
	SUBI R21,LOW(1)
	LDI  R30,LOW(32)
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+17
	LDD  R31,Y+17+1
	ICALL
	RJMP _0x200006E
_0x2000070:
_0x200006D:
_0x2000071:
_0x2000030:
_0x20000C9:
	LDI  R17,LOW(0)
_0x200001B:
	RJMP _0x2000016
_0x2000018:
	LDD  R26,Y+12
	LDD  R27,Y+12+1
	CALL __GETW1P
	CALL __LOADLOCR6
	ADIW R28,20
	RET
_sprintf:
	PUSH R15
	MOV  R15,R24
	SBIW R28,6
	CALL __SAVELOCR4
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	SBIW R30,0
	BRNE _0x2000072
	LDI  R30,LOW(65535)
	LDI  R31,HIGH(65535)
	RJMP _0x216000C
_0x2000072:
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	MOVW R16,R26
	MOVW R26,R28
	ADIW R26,12
	CALL __ADDW2R15
	CALL __GETW1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R30,LOW(0)
	STD  Y+8,R30
	STD  Y+8+1,R30
	MOVW R26,R28
	ADIW R26,10
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(_put_buff_G100)
	LDI  R31,HIGH(_put_buff_G100)
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,10
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G100
	MOVW R18,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
	MOVW R30,R18
_0x216000C:
	CALL __LOADLOCR4
	ADIW R28,10
	POP  R15
	RET

	.CSEG
_abs:
    ld   r30,y+
    ld   r31,y+
    sbiw r30,0
    brpl __abs0
    com  r30
    com  r31
    adiw r30,1
__abs0:
    ret
_itoa:
    ld   r26,y+
    ld   r27,y+
    ld   r30,y+
    ld   r31,y+
    adiw r30,0
    brpl __itoa0
    com  r30
    com  r31
    adiw r30,1
    ldi  r22,'-'
    st   x+,r22
__itoa0:
    clt
    ldi  r24,low(10000)
    ldi  r25,high(10000)
    rcall __itoa1
    ldi  r24,low(1000)
    ldi  r25,high(1000)
    rcall __itoa1
    ldi  r24,100
    clr  r25
    rcall __itoa1
    ldi  r24,10
    rcall __itoa1
    mov  r22,r30
    rcall __itoa5
    clr  r22
    st   x,r22
    ret

__itoa1:
    clr	 r22
__itoa2:
    cp   r30,r24
    cpc  r31,r25
    brlo __itoa3
    inc  r22
    sub  r30,r24
    sbc  r31,r25
    brne __itoa2
__itoa3:
    tst  r22
    brne __itoa4
    brts __itoa5
    ret
__itoa4:
    set
__itoa5:
    subi r22,-0x30
    st   x+,r22
    ret
_ftoa:
	SBIW R28,4
	LDI  R30,LOW(0)
	ST   Y,R30
	STD  Y+1,R30
	STD  Y+2,R30
	LDI  R30,LOW(63)
	STD  Y+3,R30
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+11
	LDD  R31,Y+11+1
	CPI  R30,LOW(0xFFFF)
	LDI  R26,HIGH(0xFFFF)
	CPC  R31,R26
	BRNE _0x202000D
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2020000,0
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
	RJMP _0x216000B
_0x202000D:
	CPI  R30,LOW(0x7FFF)
	LDI  R26,HIGH(0x7FFF)
	CPC  R31,R26
	BRNE _0x202000C
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2020000,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
	RJMP _0x216000B
_0x202000C:
	LDD  R26,Y+12
	TST  R26
	BRPL _0x202000F
	__GETD1S 9
	CALL __ANEGF1
	__PUTD1S 9
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(45)
	ST   X,R30
_0x202000F:
	LDD  R26,Y+8
	CPI  R26,LOW(0x7)
	BRLO _0x2020010
	LDI  R30,LOW(6)
	STD  Y+8,R30
_0x2020010:
	LDD  R17,Y+8
_0x2020011:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BREQ _0x2020013
	__GETD2S 2
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__PUTD1S 2
	RJMP _0x2020011
_0x2020013:
	__GETD1S 2
	__GETD2S 9
	CALL __ADDF12
	__PUTD1S 9
	LDI  R17,LOW(0)
	__GETD1N 0x3F800000
	__PUTD1S 2
_0x2020014:
	__GETD1S 2
	__GETD2S 9
	CALL __CMPF12
	BRLO _0x2020016
	__GETD2S 2
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 2
	SUBI R17,-LOW(1)
	CPI  R17,39
	BRLO _0x2020017
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2020000,5
	ST   -Y,R31
	ST   -Y,R30
	CALL _strcpyf
	RJMP _0x216000B
_0x2020017:
	RJMP _0x2020014
_0x2020016:
	CPI  R17,0
	BRNE _0x2020018
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(48)
	ST   X,R30
	RJMP _0x2020019
_0x2020018:
_0x202001A:
	MOV  R30,R17
	SUBI R17,1
	CPI  R30,0
	BRNE PC+3
	JMP _0x202001C
	__GETD2S 2
	__GETD1N 0x3DCCCCCD
	CALL __MULF12
	__GETD2N 0x3F000000
	CALL __ADDF12
	CALL __PUTPARD1
	CALL _floor
	__PUTD1S 2
	__GETD2S 9
	CALL __DIVF21
	CALL __CFD1U
	MOV  R16,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	LDI  R31,0
	__GETD2S 2
	CALL __CWD1
	CALL __CDF1
	CALL __MULF12
	__GETD2S 9
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 9
	RJMP _0x202001A
_0x202001C:
_0x2020019:
	LDD  R30,Y+8
	CPI  R30,0
	BRNE _0x202001D
	RJMP _0x216000A
_0x202001D:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	LDI  R30,LOW(46)
	ST   X,R30
_0x202001E:
	LDD  R30,Y+8
	SUBI R30,LOW(1)
	STD  Y+8,R30
	SUBI R30,-LOW(1)
	BREQ _0x2020020
	__GETD2S 9
	__GETD1N 0x41200000
	CALL __MULF12
	__PUTD1S 9
	CALL __CFD1U
	MOV  R16,R30
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ADIW R26,1
	STD  Y+6,R26
	STD  Y+6+1,R27
	SBIW R26,1
	MOV  R30,R16
	SUBI R30,-LOW(48)
	ST   X,R30
	MOV  R30,R16
	LDI  R31,0
	__GETD2S 9
	CALL __CWD1
	CALL __CDF1
	CALL __SWAPD12
	CALL __SUBF12
	__PUTD1S 9
	RJMP _0x202001E
_0x2020020:
_0x216000A:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LDI  R30,LOW(0)
	ST   X,R30
_0x216000B:
	LDD  R17,Y+1
	LDD  R16,Y+0
	ADIW R28,13
	RET

	.DSEG

	.CSEG

	.CSEG
_Lire_BP_I2C_Soft:

	.DSEG

	.CSEG
	ST   -Y,R17
	ST   -Y,R16
	LDI  R30,LOW(66)
	ST   -Y,R30
	RCALL _Lire_Port_I2C_Soft
	MOV  R17,R30
	LDS  R30,_Etat_BP_I2C_S1020000000
	LDI  R31,0
	SBIW R30,0
	BRNE _0x2040007
	CPI  R17,0
	BRNE _0x2040008
	MOV  R16,R17
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(66)
	ST   -Y,R30
	RCALL _Lire_Port_I2C_Soft
	MOV  R17,R30
	CP   R17,R16
	BRNE _0x2040009
	LDI  R30,LOW(1)
	STS  _Etat_BP_I2C_S1020000000,R30
	LDI  R30,LOW(0)
	RJMP _0x2160009
_0x2040009:
	LDI  R30,LOW(255)
	RJMP _0x2160009
_0x2040008:
	LDI  R30,LOW(255)
	RJMP _0x2160009
_0x2040007:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2040006
	CPI  R17,0
	BREQ _0x204000D
	MOV  R16,R17
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
	LDI  R30,LOW(66)
	ST   -Y,R30
	RCALL _Lire_Port_I2C_Soft
	MOV  R17,R30
	CP   R17,R16
	BRNE _0x204000E
	LDI  R30,LOW(0)
	STS  _Etat_BP_I2C_S1020000000,R30
	MOV  R30,R17
	RJMP _0x2160009
_0x204000E:
	LDI  R30,LOW(0)
	RJMP _0x2160009
_0x204000D:
	LDI  R30,LOW(0)
_0x2040006:
_0x2160009:
	LD   R16,Y+
	LD   R17,Y+
	RET
_Affiche_LCD:
	CALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
	JMP  _0x2160001
_RegleHTR:
	SBIW R28,35
	LDI  R30,LOW(1)
	ST   Y,R30
	CALL __SAVELOCR6
	LDI  R17,0
	LDI  R16,0
	LDI  R19,0
	__GETWRN 20,21,0
	LDI  R18,0
_0x2040011:
	RCALL _Lire_BP_I2C_Soft
	MOV  R17,R30
	MOV  R30,R18
	LDI  R31,0
	SBIW R30,0
	BREQ PC+3
	JMP _0x2040017
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x2040018
	LDD  R30,Y+44
	CP   R30,R16
	BRNE _0x204001A
	LDD  R26,Y+6
	CP   R18,R26
	BREQ _0x2040019
_0x204001A:
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,17
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+51
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	LDD  R16,Y+44
_0x2040019:
	RJMP _0x204001C
_0x2040018:
	LDD  R30,Y+44
	CP   R30,R16
	BRNE _0x204001E
	LDD  R26,Y+6
	CP   R18,R26
	BREQ _0x204001D
_0x204001E:
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,37
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,53
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+51
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	LDD  R16,Y+44
_0x204001D:
_0x204001C:
	MOV  R30,R17
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2040023
	LDD  R30,Y+44
	SUBI R30,-LOW(1)
	STD  Y+44,R30
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x2040024
	LDD  R26,Y+44
	CPI  R26,LOW(0x18)
	BRNE _0x2040025
	LDI  R30,LOW(0)
	STD  Y+44,R30
_0x2040025:
	RJMP _0x2040026
_0x2040024:
	LDD  R26,Y+44
	CPI  R26,LOW(0x20)
	BRNE _0x2040027
	LDI  R30,LOW(1)
	STD  Y+44,R30
_0x2040027:
_0x2040026:
	RJMP _0x2040022
_0x2040023:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x2040028
	LDD  R30,Y+44
	LDI  R31,0
	SBIW R30,1
	STD  Y+44,R30
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x2040029
	LDD  R26,Y+44
	CPI  R26,LOW(0xFF)
	BRNE _0x204002A
	LDI  R30,LOW(23)
	STD  Y+44,R30
_0x204002A:
	RJMP _0x204002B
_0x2040029:
	LDD  R30,Y+44
	CPI  R30,0
	BRNE _0x204002C
	LDI  R30,LOW(31)
	STD  Y+44,R30
_0x204002C:
_0x204002B:
	RJMP _0x2040022
_0x2040028:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x204002D
	LDI  R18,LOW(1)
	RJMP _0x2040022
_0x204002D:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x204002F
	LDI  R18,LOW(3)
	RJMP _0x2040022
_0x204002F:
	LDI  R18,LOW(0)
_0x2040022:
	LDI  R30,LOW(0)
	STD  Y+6,R30
	RJMP _0x2040016
_0x2040017:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2040030
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x2040031
	LDD  R30,Y+43
	CP   R30,R19
	BRNE _0x2040033
	LDD  R26,Y+6
	CP   R18,R26
	BREQ _0x2040032
_0x2040033:
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,68
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,84
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+51
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	LDD  R19,Y+43
_0x2040032:
	RJMP _0x2040035
_0x2040031:
	LDD  R30,Y+43
	CP   R30,R19
	BRNE _0x2040037
	LDD  R26,Y+6
	CP   R18,R26
	BREQ _0x2040036
_0x2040037:
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,105
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,121
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+51
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	LDD  R19,Y+43
_0x2040036:
_0x2040035:
	MOV  R30,R17
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x204003C
	LDD  R30,Y+43
	SUBI R30,-LOW(1)
	STD  Y+43,R30
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x204003D
	LDD  R26,Y+43
	CPI  R26,LOW(0x3C)
	BRNE _0x204003E
	LDI  R30,LOW(0)
	STD  Y+43,R30
_0x204003E:
	RJMP _0x204003F
_0x204003D:
	LDD  R26,Y+43
	CPI  R26,LOW(0xD)
	BRNE _0x2040040
	LDI  R30,LOW(1)
	STD  Y+43,R30
_0x2040040:
_0x204003F:
	RJMP _0x204003B
_0x204003C:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x2040041
	LDD  R30,Y+43
	LDI  R31,0
	SBIW R30,1
	STD  Y+43,R30
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x2040042
	LDD  R26,Y+43
	CPI  R26,LOW(0xFF)
	BRNE _0x2040043
	LDI  R30,LOW(59)
	STD  Y+43,R30
_0x2040043:
	RJMP _0x2040044
_0x2040042:
	LDD  R30,Y+43
	CPI  R30,0
	BRNE _0x2040045
	LDI  R30,LOW(12)
	STD  Y+43,R30
_0x2040045:
_0x2040044:
	RJMP _0x204003B
_0x2040041:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x2040046
	LDI  R18,LOW(2)
	RJMP _0x204003B
_0x2040046:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x2040048
	LDI  R18,LOW(3)
	RJMP _0x204003B
_0x2040048:
	LDI  R18,LOW(1)
_0x204003B:
	LDI  R30,LOW(1)
	STD  Y+6,R30
	RJMP _0x2040016
_0x2040030:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BREQ PC+3
	JMP _0x2040049
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x204004A
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	CP   R30,R20
	CPC  R31,R21
	BRNE _0x204004C
	LDD  R26,Y+6
	CP   R18,R26
	BREQ _0x204004B
_0x204004C:
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,136
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,152
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+51
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	__GETWRS 20,21,41
_0x204004B:
	RJMP _0x204004E
_0x204004A:
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	CP   R30,R20
	CPC  R31,R21
	BRNE _0x2040050
	LDD  R26,Y+6
	CP   R18,R26
	BREQ _0x204004F
_0x2040050:
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,172
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	CALL _sprintf
	ADIW R28,4
	MOVW R30,R28
	ADIW R30,7
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _0x2040000,188
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+48
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+51
	CLR  R31
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDD  R30,Y+53
	LDD  R31,Y+53+1
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
	MOVW R30,R28
	ADIW R30,24
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,9
	ST   -Y,R31
	ST   -Y,R30
	RCALL _Affiche_LCD
	__GETWRS 20,21,41
_0x204004F:
_0x204004E:
	MOV  R30,R17
	LDI  R31,0
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x2040055
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	ADIW R30,1
	STD  Y+41,R30
	STD  Y+41+1,R31
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x2040056
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	SBIW R26,60
	BRNE _0x2040057
	LDI  R30,LOW(0)
	STD  Y+41,R30
	STD  Y+41+1,R30
_0x2040057:
	RJMP _0x2040058
_0x2040056:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x7E5)
	LDI  R30,HIGH(0x7E5)
	CPC  R27,R30
	BRNE _0x2040059
	LDI  R30,LOW(2010)
	LDI  R31,HIGH(2010)
	STD  Y+41,R30
	STD  Y+41+1,R31
_0x2040059:
_0x2040058:
	RJMP _0x2040054
_0x2040055:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x204005A
	LDD  R30,Y+41
	LDD  R31,Y+41+1
	SBIW R30,1
	STD  Y+41,R30
	STD  Y+41+1,R31
	LDD  R30,Y+45
	CPI  R30,0
	BRNE _0x204005B
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0xFFFF)
	LDI  R30,HIGH(0xFFFF)
	CPC  R27,R30
	BRNE _0x204005C
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	STD  Y+41,R30
	STD  Y+41+1,R31
_0x204005C:
	RJMP _0x204005D
_0x204005B:
	LDD  R26,Y+41
	LDD  R27,Y+41+1
	CPI  R26,LOW(0x7D9)
	LDI  R30,HIGH(0x7D9)
	CPC  R27,R30
	BRNE _0x204005E
	LDI  R30,LOW(2020)
	LDI  R31,HIGH(2020)
	STD  Y+41,R30
	STD  Y+41+1,R31
_0x204005E:
_0x204005D:
	RJMP _0x2040054
_0x204005A:
	CPI  R30,LOW(0x20)
	LDI  R26,HIGH(0x20)
	CPC  R31,R26
	BRNE _0x204005F
	LDI  R18,LOW(0)
	RJMP _0x2040054
_0x204005F:
	CPI  R30,LOW(0x80)
	LDI  R26,HIGH(0x80)
	CPC  R31,R26
	BRNE _0x2040061
	LDI  R18,LOW(3)
	RJMP _0x2040054
_0x2040061:
	LDI  R18,LOW(2)
_0x2040054:
	LDI  R30,LOW(2)
	STD  Y+6,R30
	RJMP _0x2040016
_0x2040049:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x2040016
	LDD  R26,Y+45
	CPI  R26,LOW(0x1)
	BRNE _0x2040063
	LDD  R30,Y+46
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_set_date
	RJMP _0x2040064
_0x2040063:
	LDD  R30,Y+46
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+45
	ST   -Y,R30
	LDD  R30,Y+44
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _rtc_set_time
_0x2040064:
	LDI  R30,LOW(0)
	LDI  R31,HIGH(0)
	RJMP _0x2160008
_0x2040016:
	RJMP _0x2040011
_0x2160008:
	CALL __LOADLOCR6
	ADIW R28,47
	RET

	.CSEG
_Ecrire_Port_I2C_Soft:
	CALL _i2c_start
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
	JMP  _0x2160005
_Lire_Port_I2C_Soft:
	ST   -Y,R17
	CALL _i2c_start
	LDD  R30,Y+1
	ORI  R30,1
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R17,R30
	CALL _i2c_stop
	MOV  R30,R17
	LDD  R17,Y+0
	JMP  _0x2160005

	.CSEG
_ds1621_get_status:
	ST   -Y,R17
	ST   -Y,R16
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0x90)
	MOV  R17,R30
	CALL _i2c_start
	ST   -Y,R17
	CALL _i2c_write
	LDI  R30,LOW(172)
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	SUBI R17,-LOW(1)
	ST   -Y,R17
	CALL _i2c_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R16,R30
	CALL _i2c_stop
	MOV  R30,R16
	LDD  R17,Y+1
	LDD  R16,Y+0
	JMP  _0x2160003
_ds1621_set_status:
	CALL _i2c_start
	LDD  R30,Y+1
	LSL  R30
	ORI  R30,LOW(0x90)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(172)
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
	JMP  _0x2160005
_ds1621_set_temp:
	CALL _i2c_start
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0x90)
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
_0x2080003:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _ds1621_get_status
	ANDI R30,LOW(0x10)
	BRNE _0x2080003
	JMP  _0x2160003
_ds1621_start:
	CALL _i2c_start
	LD   R30,Y
	LSL  R30
	ORI  R30,LOW(0x90)
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(238)
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
	JMP  _0x2160002
_ds1621_init:
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+1
	LSL  R30
	SUBI R30,-LOW(8)
	ST   -Y,R30
	RCALL _ds1621_set_status
	LDD  R30,Y+3
	ST   -Y,R30
	LDI  R30,LOW(162)
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _ds1621_set_temp
	LDD  R30,Y+3
	ST   -Y,R30
	LDI  R30,LOW(161)
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	RCALL _ds1621_set_temp
	LDD  R30,Y+3
	ST   -Y,R30
	RCALL _ds1621_start
	JMP  _0x2160001
_ds1621_temperature_10:
	SBIW R28,2
	ST   -Y,R17
	LDD  R30,Y+3
	LSL  R30
	ORI  R30,LOW(0x90)
	MOV  R17,R30
	CALL _i2c_start
	ST   -Y,R17
	CALL _i2c_write
	LDI  R30,LOW(170)
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	SUBI R17,-LOW(1)
	ST   -Y,R17
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	STD  Y+2,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	STD  Y+1,R30
	CALL _i2c_stop
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(7)
	CALL __ASRW12
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12
	LDD  R17,Y+0
	JMP  _0x2160001

	.CSEG
_rtc_read:
	ST   -Y,R17
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	MOV  R17,R30
	CALL _i2c_start
	ST   -Y,R17
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	MOV  R30,R17
	ORI  R30,1
	ST   -Y,R30
	CALL _i2c_write
	LDI  R30,LOW(0)
	ST   -Y,R30
	CALL _i2c_read
	MOV  R17,R30
	CALL _i2c_stop
	MOV  R30,R17
	JMP  _0x2160004
_rtc_write:
	CALL _i2c_start
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0xA0)
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_stop
	JMP  _0x2160003
_rtc_get_status:
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	RCALL _rtc_read
	STS  ___rtc_status,R30
	BST  R30,1
	BLD  R2,0
	JMP  _0x2160002
_rtc_init:
	ST   -Y,R17
	LDI  R17,LOW(144)
	LDD  R30,Y+1
	CPI  R30,0
	BREQ _0x20A0003
	LDI  R17,LOW(176)
_0x20A0003:
	LDI  R30,LOW(0)
	STS  ___rtc_status,R30
	CLT
	BLD  R2,0
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R30
	RCALL _rtc_write
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _rtc_read
	ANDI R30,LOW(0x3F)
	ST   -Y,R30
	RCALL _rtc_write
	LDD  R30,Y+2
	ST   -Y,R30
	LDI  R30,LOW(8)
	ST   -Y,R30
	ST   -Y,R17
	RCALL _rtc_write
	JMP  _0x2160004
_rtc_stop:
	LD   R30,Y
	ST   -Y,R30
	RCALL _rtc_get_status
	LDS  R30,___rtc_status
	ORI  R30,0x80
	STS  ___rtc_status,R30
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,___rtc_status
	ST   -Y,R30
	RCALL _rtc_write
	JMP  _0x2160002
_rtc_start:
	LD   R30,Y
	ST   -Y,R30
	RCALL _rtc_get_status
	LDS  R30,___rtc_status
	ANDI R30,0x7F
	STS  ___rtc_status,R30
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,___rtc_status
	ST   -Y,R30
	RCALL _rtc_write
	JMP  _0x2160002
_rtc_hold_off:
	LD   R30,Y
	ST   -Y,R30
	RCALL _rtc_get_status
	LDS  R30,___rtc_status
	ANDI R30,0xBF
	STS  ___rtc_status,R30
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,___rtc_status
	ST   -Y,R30
	RCALL _rtc_write
	JMP  _0x2160002
_rtc_hold_on:
	LD   R30,Y
	ST   -Y,R30
	RCALL _rtc_get_status
	LDS  R30,___rtc_status
	ORI  R30,0x40
	STS  ___rtc_status,R30
	LD   R30,Y
	ST   -Y,R30
	LDI  R30,LOW(0)
	ST   -Y,R30
	LDS  R30,___rtc_status
	ST   -Y,R30
	RCALL _rtc_write
	JMP  _0x2160002
_rtc_read_bcd:
	LDD  R30,Y+1
	ST   -Y,R30
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL _rtc_read
	ST   -Y,R30
	CALL _bcd2bin
	JMP  _0x2160005
_rtc_write_bcd:
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _bin2bcd
	ST   -Y,R30
	RCALL _rtc_write
	JMP  _0x2160003
_rtc_write_word:
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _rtc_write
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+3
	SUBI R30,-LOW(1)
	STD  Y+3,R30
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	RCALL _rtc_write
	JMP  _0x2160001
_rtc_write_date:
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	CALL _bin2bcd
	MOV  R26,R30
	LDD  R30,Y+2
	ANDI R30,LOW(0x3)
	SWAP R30
	ANDI R30,0xF0
	LSL  R30
	LSL  R30
	OR   R30,R26
	ST   -Y,R30
	RCALL _rtc_write
	RJMP _0x2160007
_rtc_get_time:
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _rtc_hold_on
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LD   R26,Y
	LDD  R27,Y+1
	ST   X,R30
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	ST   X,R30
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X,R30
	LDD  R30,Y+8
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	RCALL _rtc_read_bcd
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ST   X,R30
	LDD  R30,Y+8
	ST   -Y,R30
	RCALL _rtc_hold_off
	ADIW R28,9
	RET
_rtc_set_time:
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _rtc_stop
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(1)
	ST   -Y,R30
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _rtc_write_bcd
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(2)
	ST   -Y,R30
	LDD  R30,Y+3
	ST   -Y,R30
	RCALL _rtc_write_bcd
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(3)
	ST   -Y,R30
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _rtc_write_bcd
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(4)
	ST   -Y,R30
	LDD  R30,Y+5
	RJMP _0x2160006
_rtc_get_date:
	CALL __SAVELOCR4
	LDD  R30,Y+10
	ST   -Y,R30
	RCALL _rtc_hold_on
	LDD  R30,Y+10
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	RCALL _rtc_read
	MOV  R17,R30
	LDD  R30,Y+10
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	RCALL _rtc_read
	ANDI R30,LOW(0x1F)
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	ST   X,R30
	LDD  R30,Y+10
	ST   -Y,R30
	RCALL _rtc_hold_off
	MOV  R30,R17
	ANDI R30,LOW(0x3F)
	ST   -Y,R30
	CALL _bcd2bin
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	ST   X,R30
	MOV  R26,R17
	LDI  R27,0
	LDI  R30,LOW(6)
	CALL __ASRW12
	MOV  R17,R30
	LDD  R30,Y+10
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _rtc_read
	MOV  R16,R30
	LDD  R30,Y+10
	ST   -Y,R30
	LDI  R30,LOW(17)
	ST   -Y,R30
	RCALL _rtc_read
	MOV  R31,R30
	LDI  R30,0
	OR   R30,R16
	MOVW R18,R30
	MOV  R30,R18
	ANDI R30,LOW(0x3)
	CP   R17,R30
	BREQ _0x20A0004
	LDD  R30,Y+10
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	__ADDWRN 18,19,1
	ST   -Y,R19
	ST   -Y,R18
	RCALL _rtc_write_word
_0x20A0004:
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	ST   X+,R18
	ST   X,R19
	CALL __LOADLOCR4
	ADIW R28,11
	RET
_rtc_set_date:
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(16)
	ST   -Y,R30
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_write_word
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _rtc_stop
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(5)
	ST   -Y,R30
	LDD  R30,Y+5
	ST   -Y,R30
	LDD  R30,Y+3
	LDD  R31,Y+3+1
	ST   -Y,R31
	ST   -Y,R30
	RCALL _rtc_write_date
	LDD  R30,Y+4
	ST   -Y,R30
	LDI  R30,LOW(6)
	ST   -Y,R30
	LDD  R30,Y+4
_0x2160006:
	ST   -Y,R30
	RCALL _rtc_write_bcd
	LDD  R30,Y+4
	ST   -Y,R30
	RCALL _rtc_start
_0x2160007:
	ADIW R28,5
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG

	.CSEG
__lcd_delay_G106:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
	RET
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
	RCALL __lcd_delay_G106
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G106
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
	RCALL __lcd_delay_G106
    sbi   __lcd_port,__lcd_enable ;EN=1
	RCALL __lcd_delay_G106
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble_G106:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G106
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G106
	RET
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf0 | (1<<__lcd_rs) | (1<<__lcd_rd) | (1<<__lcd_enable) ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	RCALL __lcd_write_nibble_G106
    ld    r26,y
    swap  r26
	RCALL __lcd_write_nibble_G106
    sbi   __lcd_port,__lcd_rd     ;RD=1
	JMP  _0x2160002
_lcd_write_byte:
	CALL __lcd_ready
	LDD  R30,Y+1
	ST   -Y,R30
	RCALL __lcd_write_data
	CALL __lcd_ready
    sbi   __lcd_port,__lcd_rs     ;RS=1
	LD   R30,Y
	ST   -Y,R30
	RCALL __lcd_write_data
	RJMP _0x2160005
__lcd_read_nibble_G106:
    sbi   __lcd_port,__lcd_enable ;EN=1
	CALL __lcd_delay_G106
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
	CALL __lcd_delay_G106
    andi  r30,0xf0
	RET
_lcd_read_byte0_G106:
	CALL __lcd_delay_G106
	RCALL __lcd_read_nibble_G106
    mov   r26,r30
	RCALL __lcd_read_nibble_G106
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	LDI  R31,0
	SUBI R30,LOW(-__base_y_G106)
	SBCI R31,HIGH(-__base_y_G106)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R5,Y+1
	LDD  R4,Y+0
_0x2160005:
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(12)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL __lcd_ready
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	LDI  R30,LOW(0)
	MOV  R4,R30
	MOV  R5,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	CP   R5,R7
	BRLO _0x20C0004
	__lcd_putchar1:
	INC  R4
	LDI  R30,LOW(0)
	ST   -Y,R30
	ST   -Y,R4
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x20C0004:
	INC  R5
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	JMP  _0x2160002
_lcd_puts:
	ST   -Y,R17
_0x20C0005:
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LD   R30,X+
	STD  Y+1,R26
	STD  Y+1+1,R27
	MOV  R17,R30
	CPI  R30,0
	BREQ _0x20C0007
	ST   -Y,R17
	RCALL _lcd_putchar
	RJMP _0x20C0005
_0x20C0007:
_0x2160004:
	LDD  R17,Y+0
_0x2160003:
	ADIW R28,3
	RET
__long_delay_G106:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G106:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
	CALL __lcd_write_nibble_G106
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RJMP _0x2160002
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R7,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G106,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G106,3
	RCALL __long_delay_G106
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(48)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G106
	RCALL __long_delay_G106
	LDI  R30,LOW(40)
	ST   -Y,R30
	CALL __lcd_write_data
	RCALL __long_delay_G106
	LDI  R30,LOW(4)
	ST   -Y,R30
	CALL __lcd_write_data
	RCALL __long_delay_G106
	LDI  R30,LOW(133)
	ST   -Y,R30
	CALL __lcd_write_data
	RCALL __long_delay_G106
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G106
	CPI  R30,LOW(0x5)
	BREQ _0x20C000B
	LDI  R30,LOW(0)
	RJMP _0x2160002
_0x20C000B:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x2160002:
	ADIW R28,1
	RET

	.CSEG

	.CSEG
_strcpyf:
    ld   r30,y+
    ld   r31,y+
    ld   r26,y+
    ld   r27,y+
    movw r24,r26
strcpyf0:
	lpm  r0,z+
    st   x+,r0
    tst  r0
    brne strcpyf0
    movw r30,r24
    ret
_strlen:
    ld   r26,y+
    ld   r27,y+
    clr  r30
    clr  r31
strlen0:
    ld   r22,x+
    tst  r22
    breq strlen1
    adiw r30,1
    rjmp strlen0
strlen1:
    ret
_strlenf:
    clr  r26
    clr  r27
    ld   r30,y+
    ld   r31,y+
strlenf0:
	lpm  r0,z+
    tst  r0
    breq strlenf1
    adiw r26,1
    rjmp strlenf0
strlenf1:
    movw r30,r26
    ret

	.CSEG
_ftrunc:
   ldd  r23,y+3
   ldd  r22,y+2
   ldd  r31,y+1
   ld   r30,y
   bst  r23,7
   lsl  r23
   sbrc r22,7
   sbr  r23,1
   mov  r25,r23
   subi r25,0x7e
   breq __ftrunc0
   brcs __ftrunc0
   cpi  r25,24
   brsh __ftrunc1
   clr  r26
   clr  r27
   clr  r24
__ftrunc2:
   sec
   ror  r24
   ror  r27
   ror  r26
   dec  r25
   brne __ftrunc2
   and  r30,r26
   and  r31,r27
   and  r22,r24
   rjmp __ftrunc1
__ftrunc0:
   clt
   clr  r23
   clr  r30
   clr  r31
   clr  r22
__ftrunc1:
   cbr  r22,0x80
   lsr  r23
   brcc __ftrunc3
   sbr  r22,0x80
__ftrunc3:
   bld  r23,7
   ld   r26,y+
   ld   r27,y+
   ld   r24,y+
   ld   r25,y+
   cp   r30,r26
   cpc  r31,r27
   cpc  r22,r24
   cpc  r23,r25
   bst  r25,7
   ret
_floor:
	CALL __GETD1S0
	CALL __PUTPARD1
	CALL _ftrunc
	CALL __PUTD1S0
    brne __floor1
__floor0:
	CALL __GETD1S0
	RJMP _0x2160001
__floor1:
    brtc __floor0
	CALL __GETD1S0
	__GETD2N 0x3F800000
	CALL __SUBF12
_0x2160001:
	ADIW R28,4
	RET

	.CSEG
_bcd2bin:
    ld   r30,y
    swap r30
    andi r30,0xf
    mov  r26,r30
    lsl  r26
    lsl  r26
    add  r30,r26
    lsl  r30
    ld   r26,y+
    andi r26,0xf
    add  r30,r26
    ret
_bin2bcd:
    ld   r26,y+
    clr  r30
bin2bcd0:
    subi r26,10
    brmi bin2bcd1
    subi r30,-16
    rjmp bin2bcd0
bin2bcd1:
    subi r26,-10
    add  r30,r26
    ret

	.DSEG
___rtc_status:
	.BYTE 0x1
__seed_G101:
	.BYTE 0x4
_Etat_BP_I2C_S1020000000:
	.BYTE 0x1
__base_y_G106:
	.BYTE 0x4

	.CSEG

	.CSEG
	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_read3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_read3
	rcall __i2c_delay1
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
__i2c_write3:
	sbis __i2c_pin,__scl_bit
	rjmp __i2c_write3
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	rjmp __i2c_delay1

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGF1:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __ANEGF10
	SUBI R23,0x80
__ANEGF10:
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF1211
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF1211:
	BRCC __ADDF128
	RJMP __ADDF129
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__CMPF12:
	TST  R25
	BRMI __CMPF120
	TST  R23
	BRMI __CMPF121
	CP   R25,R23
	BRLO __CMPF122
	BRNE __CMPF121
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	BRLO __CMPF122
	BREQ __CMPF123
__CMPF121:
	CLZ
	CLC
	RET
__CMPF122:
	CLZ
	SEC
	RET
__CMPF123:
	SEZ
	CLC
	RET
__CMPF120:
	TST  R23
	BRPL __CMPF122
	CP   R25,R23
	BRLO __CMPF121
	BRNE __CMPF122
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	BRLO __CMPF122
	BREQ __CMPF123
	RJMP __CMPF121

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__ANEGD1:
	COM  R31
	COM  R22
	COM  R23
	NEG  R30
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__CBD1:
	MOV  R31,R30
	ADD  R31,R31
	SBC  R31,R31
	MOV  R22,R31
	MOV  R23,R31
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21U:
	RCALL __DIVW21U
	MOVW R30,R26
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__GETD1S0:
	LD   R30,Y
	LDD  R31,Y+1
	LDD  R22,Y+2
	LDD  R23,Y+3
	RET

__PUTD1S0:
	ST   Y,R30
	STD  Y+1,R31
	STD  Y+2,R22
	STD  Y+3,R23
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__CPD12:
	CP   R30,R26
	CPC  R31,R27
	CPC  R22,R24
	CPC  R23,R25
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD  R26,R28
	ADC  R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
